(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/common'), require('@angular/material/toolbar'), require('@angular/material/icon'), require('tslib'), require('@angular/material/list'), require('@angular/material/divider'), require('@angular/material/core'), require('@angular/material/expansion'), require('@angular/material/tooltip'), require('@angular/cdk/bidi'), require('@angular/material/sidenav'), require('@angular/material/card'), require('@angular/material/select'), require('@angular/material/form-field'), require('@angular/material/menu'), require('@angular/cdk/overlay'), require('@angular/animations'), require('@angular/material/bottom-sheet'), require('@angular/material/button'), require('@angular/material/progress-bar')) :
    typeof define === 'function' && define.amd ? define('@brightlayer-ui/angular-components', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/common', '@angular/material/toolbar', '@angular/material/icon', 'tslib', '@angular/material/list', '@angular/material/divider', '@angular/material/core', '@angular/material/expansion', '@angular/material/tooltip', '@angular/cdk/bidi', '@angular/material/sidenav', '@angular/material/card', '@angular/material/select', '@angular/material/form-field', '@angular/material/menu', '@angular/cdk/overlay', '@angular/animations', '@angular/material/bottom-sheet', '@angular/material/button', '@angular/material/progress-bar'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['brightlayer-ui'] = global['brightlayer-ui'] || {}, global['brightlayer-ui']['angular-components'] = {}), global.ng.core, global.rxjs, global.rxjs.operators, global.ng.common, global.ng.material.toolbar, global.ng.material.icon, global.tslib, global.ng.material.list, global.ng.material.divider, global.ng.material.core, global.ng.material.expansion, global.ng.material.tooltip, global.ng.cdk.bidi, global.ng.material.sidenav, global.ng.material.card, global.ng.material.select, global.ng.material.formField, global.ng.material.menu, global.ng.cdk.overlay, global.ng.animations, global.ng.material.bottomSheet, global.ng.material.button, global.ng.material.progressBar));
}(this, (function (exports, i0, rxjs, operators, common, toolbar, icon, tslib, list, divider, core, expansion, tooltip, bidi, sidenav, card, select, formField, menu, overlay, animations, bottomSheet, button, progressBar) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    /**
     * [AppBar Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-app-bar--readme)
     *
     * The `<blui-app-bar>` component is a wrapper around the `<mat-toolbar>` that can be resized as the page is scrolled.
     * It supports three variants: `snap`, `collapsed`, and `expanded`.
     * */
    var AppBarComponent = /** @class */ (function () {
        function AppBarComponent(_ref) {
            this._ref = _ref;
            /** Color variant which is passed to the `<mat-toolbar>`
             *
             * @default primary
             * */
            this.color = 'primary';
            /** Height (pixels) of the AppBar when expanded
             *
             * @default 200
             * */
            this.expandedHeight = 200;
            /** Behavior of the App Bar
             *
             *  `collapsed` - Height set to `collapsedHeight` and does not respond to scroll distance
             *
             *  `expanded` -  Height set to `expandedHeight` and does not respond to scroll distance
             *
             *  `snap` - Variant that responds to scroll distance and switches between the `collapsed` and `expanded` variant.
             *
             *  @default collapsed
             *
             * */
            this.variant = 'collapsed';
            /** Event emitter for when the appbar opens or closes.  Emits a boolean that indicates whether the AppBar is expanded. */
            this.collapsedChange = new i0.EventEmitter();
            this.isCollapsed = false;
            this.isWindow = false;
            this.useDefaultCollapsedHeight = true;
            this.viewInit = false;
            this.contentSize = 0;
        }
        AppBarComponent.prototype.ngOnInit = function () {
            if (!this.scrollThreshold) {
                this.scrollThreshold = this.expandedHeight - (this.collapsedHeight || 64);
            }
        };
        AppBarComponent.prototype.ngOnChanges = function (changes) {
            if (changes.variant) {
                this._resizeOnModeChange();
            }
            this.useDefaultCollapsedHeight = isNaN(this.collapsedHeight) || this.collapsedHeight === 0;
            this.expandedHeight = Number(this.expandedHeight);
            this.collapsedHeight = Number(this.collapsedHeight);
            this._ref.detectChanges();
        };
        AppBarComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            this._setScrollEl();
            this._resizeOnModeChange();
            this.viewInit = true;
            if (this.scrollEl) {
                this.scrollListener = rxjs.fromEvent(this.scrollEl, 'scroll')
                    .pipe(operators.throttle(function () { return rxjs.interval(10); }))
                    .subscribe(function () {
                    _this._resizeEl();
                });
                this.resizeListener = rxjs.fromEvent(window, 'resize')
                    .pipe(operators.throttle(function () { return rxjs.interval(10); }))
                    .subscribe(function () {
                    _this._resizeEl();
                });
            }
        };
        AppBarComponent.prototype.ngOnDestroy = function () {
            if (this.scrollListener) {
                this.scrollListener.unsubscribe();
            }
            if (this.resizeListener) {
                this.resizeListener.unsubscribe();
            }
        };
        AppBarComponent.prototype.calcCurrentToolbarHeight = function () {
            if (!this.isCollapsed) {
                return this.expandedHeight + "px";
            }
            else if (!this.useDefaultCollapsedHeight) {
                return this.collapsedHeight + "px";
            }
            return this._calcDefaultCollapsedHeight() + "rem";
        };
        AppBarComponent.prototype._resizeOnModeChange = function () {
            if (this.variant !== 'snap') {
                return this._handleLockedModes();
            }
            else if (this.scrollEl) {
                this._resizeEl();
            }
        };
        AppBarComponent.prototype._handleLockedModes = function () {
            if (this.variant === 'collapsed') {
                this._setCollapsed(true);
                this._ref.detectChanges();
                return;
            }
            if (this.variant === 'expanded') {
                this._setCollapsed(false);
                this._ref.detectChanges();
                return;
            }
        };
        AppBarComponent.prototype._setCollapsed = function (collapsed) {
            this.isCollapsed = collapsed;
            this.collapsedChange.emit(collapsed);
        };
        AppBarComponent.prototype._resizeEl = function () {
            var _this = this;
            if (this.isAnimating) {
                return;
            }
            if (this.variant !== 'snap') {
                return this._handleLockedModes();
            }
            var scrollDistance = this.isWindow ? document.scrollingElement.scrollTop : this.scrollEl.scrollTop;
            if (this.isCollapsed && scrollDistance <= 0) {
                this._setCollapsed(false);
                this._ref.detectChanges();
            }
            else if (scrollDistance > this.scrollThreshold && !this.isCollapsed) {
                this._setCollapsed(true);
                this.isAnimating = true;
                this._ref.detectChanges();
                setTimeout(function () {
                    var currScrollDistance = _this.isWindow
                        ? document.scrollingElement.scrollTop
                        : _this.scrollEl.scrollTop;
                    if (currScrollDistance <= 0) {
                        if (_this.isWindow) {
                            window.scrollBy(0, 1);
                        }
                        else {
                            _this.scrollEl.scrollTop = 1;
                        }
                    }
                    _this.isAnimating = false;
                }, 300);
            }
        };
        AppBarComponent.prototype._setScrollEl = function () {
            if (this.scrollContainerElement) {
                this.scrollEl = this.scrollContainerElement;
            }
            else if (this.scrollContainerId) {
                this.scrollEl = document.getElementById(this.scrollContainerId);
            }
            else if (this.scrollContainerClassName) {
                this.scrollEl = document.getElementsByClassName(this.scrollContainerClassName.name)[this.scrollContainerClassName.index];
            }
            else {
                this.scrollEl = window;
                this.isWindow = true;
            }
        };
        AppBarComponent.prototype._calcDefaultCollapsedHeight = function () {
            return document.documentElement.clientWidth <= 600 ? 3.5 : 4;
        };
        return AppBarComponent;
    }());
    AppBarComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-app-bar',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    host: {
                        class: 'blui-app-bar mat-elevation-z4',
                    },
                    template: "\n        <mat-toolbar\n            [color]=\"color\"\n            class=\"blui-app-bar-content\"\n            [class.blui-app-bar-collapsed]=\"isCollapsed\"\n            [class.blui-app-bar-expanded]=\"!isCollapsed\"\n            [class.blui-app-bar-view-init]=\"viewInit\"\n            [style.height]=\"calcCurrentToolbarHeight()\"\n        >\n            <mat-toolbar-row>\n                <div class=\"blui-app-bar-background\"></div>\n                <ng-content select=\"[blui-icon]\"></ng-content>\n                <div class=\"blui-app-bar-body-wrapper\">\n                    <ng-content></ng-content>\n                </div>\n                <blui-spacer></blui-spacer>\n                <ng-content select=\"[blui-actions]\"></ng-content>\n            </mat-toolbar-row>\n        </mat-toolbar>\n    ",
                    styles: [".blui-app-bar{display:flex;position:sticky;position:-webkit-sticky;top:0;z-index:1000}.blui-app-bar-content{min-height:unset;transition:all .3s;overflow:hidden}.blui-app-bar-content *{z-index:2}.blui-app-bar-collapsed .blui-app-bar-body-wrapper>*{top:0}.blui-app-bar-body-wrapper>*{position:relative}.blui-app-bar-view-init .blui-app-bar-body-wrapper>*{transition:all .3s}.blui-app-bar-content:not(.blui-app-bar-view-init) .blui-app-bar-body-wrapper *{transition:none}.blui-app-bar-background{z-index:1;position:absolute;opacity:.3;background-position:center;background-size:cover;pointer-events:none;top:0;left:0;right:0;bottom:0;transition:all .3s}.blui-app-bar-collapsed .blui-app-bar-background{opacity:0}.blui-app-bar-collapsed .blui-three-liner-title{font-size:1.25rem}.blui-app-bar-collapsed .blui-three-liner-subtitle{font-size:0px}.blui-app-bar-collapsed .blui-three-liner-info{margin-top:-.5rem;font-size:1rem;font-weight:400}\n"]
                },] }
    ];
    AppBarComponent.ctorParameters = function () { return [
        { type: i0.ChangeDetectorRef }
    ]; };
    AppBarComponent.propDecorators = {
        collapsedHeight: [{ type: i0.Input }],
        color: [{ type: i0.Input }],
        expandedHeight: [{ type: i0.Input }],
        scrollContainerElement: [{ type: i0.Input }],
        scrollContainerClassName: [{ type: i0.Input }],
        scrollContainerId: [{ type: i0.Input }],
        scrollThreshold: [{ type: i0.Input }],
        variant: [{ type: i0.Input }],
        collapsedChange: [{ type: i0.Output }]
    };

    /**
     * [Spacer Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-spacer--readme)
     *
     * An invisible utility component that acts as a spacer element in various layouts.
     * It works with flexbox sizing or fixed sizing.
     */
    var SpacerComponent = /** @class */ (function () {
        function SpacerComponent() {
            /** Flex grow/shrink value for use in flex layouts
             *
             * @default 1
             * */
            this.flex = 1;
            this.display = 'flex';
        }
        SpacerComponent.prototype.ngOnInit = function () {
            this.calcGrow();
        };
        SpacerComponent.prototype.ngOnChanges = function () {
            this.calcGrow();
        };
        SpacerComponent.prototype.calcGrow = function () {
            this.grow = undefined;
            if (!this.height && !this.width) {
                this.grow = this.flex + " " + this.flex + " " + (this.flex === 0 ? 'auto' : '0px');
            }
        };
        return SpacerComponent;
    }());
    SpacerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-spacer',
                    template: " <ng-content></ng-content> "
                },] }
    ];
    SpacerComponent.propDecorators = {
        flex: [{ type: i0.Input }],
        height: [{ type: i0.HostBinding, args: ['style.height.px',] }, { type: i0.Input }],
        width: [{ type: i0.HostBinding, args: ['style.width.px',] }, { type: i0.Input }],
        grow: [{ type: i0.HostBinding, args: ['style.flex',] }],
        display: [{ type: i0.HostBinding, args: ['style.display',] }]
    };
    var SpacerModule = /** @class */ (function () {
        function SpacerModule() {
        }
        return SpacerModule;
    }());
    SpacerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [SpacerComponent],
                    exports: [SpacerComponent],
                },] }
    ];

    var AppBarModule = /** @class */ (function () {
        function AppBarModule() {
        }
        return AppBarModule;
    }());
    AppBarModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [AppBarComponent],
                    imports: [common.CommonModule, toolbar.MatToolbarModule, SpacerModule, icon.MatIconModule],
                    exports: [AppBarComponent],
                },] }
    ];

    function requireInput(inputs, component) {
        inputs.forEach(function (input) {
            if (component[input] === undefined || component[input] === null || component[input] === '') {
                var name = component.constructor.name;
                // eslint-disable-next-line no-console
                console.warn("Brightlayer UI " + name + " error: Property \"" + input + "\" is required.");
            }
        });
    }
    function requireContent(contentPairs, component) {
        contentPairs.forEach(function (contentPair) {
            if (!contentPair.ref.nativeElement.children || contentPair.ref.nativeElement.children.length === 0) {
                var name = component.constructor.name;
                // eslint-disable-next-line no-console
                console.warn("Brightlayer UI " + name + " error: Selector \"" + contentPair.selector + "\" is required.");
            }
        });
    }
    function hasChildren(el) {
        return el.nativeElement.children && el.nativeElement.children.length > 0;
    }
    function isEmptyView(el) {
        if (!el || !el.nativeElement) {
            return true;
        }
        return !hasChildren(el);
    }

    /** [ChannelValue Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-channel-value--readme)
     *
     * Displays a value/unit combination.
     * These are used as part of the HeroComponent but can also be used inline.
     * */
    var ChannelValueComponent = /** @class */ (function () {
        function ChannelValueComponent() {
            /** If true, shows units before the value
             *
             * @default false
             * */
            this.prefix = false;
            /** Show a space between the value and units. Can be `show` | `hide` | `auto`
             *
             * `show` - Show a space between the value and units.
             *
             * `hide` - Hide a space between the value and units.
             *
             * `auto` - Shows space except for white list items.
             *
             * prefixUnitWhitelist: ['$']
             *
             * suffixUnitWhitelist: ['%', '℉','°F','℃','°C','°']
             *
             * @default auto;
             * */
            this.unitSpace = 'auto';
            this.prefixUnitWhitelist = ['$'];
            this.suffixUnitWhitelist = ['%', '℉', '°F', '℃', '°C', '°'];
            this.isWhiteListedUnit = false;
        }
        ChannelValueComponent.prototype.ngOnChanges = function () {
            requireInput(['value'], this);
            this.isWhiteListedUnit = this.prefix
                ? this.prefixUnitWhitelist.includes(this.units)
                : this.suffixUnitWhitelist.includes(this.units);
        };
        return ChannelValueComponent;
    }());
    ChannelValueComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-channel-value',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <span class=\"blui-channel-value-content\" [style.color]=\"color\">\n            <span class=\"blui-channel-value-icon-wrapper\">\n                <ng-content></ng-content>\n            </span>\n            <div\n                *ngIf=\"units && prefix\"\n                class=\"blui-channel-value-units\"\n                [class.blui-channel-value-units-prefix]=\"!isWhiteListedUnit || unitSpace === 'show'\"\n            >\n                {{ units }}\n            </div>\n            <div\n                *ngIf=\"value\"\n                class=\"blui-channel-value-value\"\n                [class.blui-channel-value-remove-space]=\"unitSpace === 'hide'\"\n            >\n                {{ value }}\n            </div>\n            <div\n                *ngIf=\"units && !prefix\"\n                class=\"blui-channel-value-units\"\n                [class.blui-channel-value-units-suffix]=\"!isWhiteListedUnit || unitSpace === 'show'\"\n            >\n                {{ units }}\n            </div>\n        </span>\n    ",
                    host: {
                        class: 'blui-channel-value',
                    },
                    styles: ["[dir=rtl] .blui-channel-value-content .blui-channel-value-icon-wrapper{margin-right:0;margin-left:.35em}[dir=rtl] .blui-channel-value-content .blui-channel-value-value+.blui-channel-value-units-suffix{margin-left:0;margin-right:.25em}[dir=rtl] .blui-channel-value-content .blui-channel-value-units-prefix+.blui-channel-value-value{margin-left:0;margin-right:.25em}[dir=rtl] .blui-channel-value-content .blui-channel-value-value.blui-channel-value-remove-space+.blui-channel-value-units-suffix{margin-left:0;margin-right:0}[dir=rtl] .blui-channel-value-content .blui-channel-value-units-prefix+.blui-channel-value-value.blui-channel-value-remove-space{margin-left:0;margin-right:0}.blui-channel-value{display:inline-flex}.blui-channel-value-content{display:inline-flex;align-items:center;line-height:1.2;font-size:inherit;letter-spacing:0;margin:0}.blui-channel-value-content .blui-channel-value-units{font-weight:300}.blui-channel-value-content .blui-channel-value-value{font-weight:600}.blui-channel-value-content .blui-channel-value-value+.blui-channel-value-units-suffix{margin-left:.25em}.blui-channel-value-content .blui-channel-value-units-prefix+.blui-channel-value-value{margin-left:.25em}.blui-channel-value-content .blui-channel-value-value.blui-channel-value-remove-space+.blui-channel-value-units-suffix{margin-left:0}.blui-channel-value-content .blui-channel-value-units-prefix+.blui-channel-value-value.blui-channel-value-remove-space{margin-left:0}.blui-channel-value-content .blui-channel-value-icon-wrapper{font-size:inherit;display:block;margin-right:.35em}.blui-channel-value-content .blui-channel-value-icon-wrapper:empty{display:none}.blui-channel-value-content .blui-channel-value-icon-wrapper *{display:block;width:100%;height:100%;font-size:100%;line-height:1.2}\n"]
                },] }
    ];
    ChannelValueComponent.propDecorators = {
        prefix: [{ type: i0.Input }],
        units: [{ type: i0.Input }],
        value: [{ type: i0.Input }],
        color: [{ type: i0.Input }],
        unitSpace: [{ type: i0.Input }]
    };

    var ChannelValueModule = /** @class */ (function () {
        function ChannelValueModule() {
        }
        return ChannelValueModule;
    }());
    ChannelValueModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [ChannelValueComponent],
                    imports: [common.CommonModule],
                    exports: [ChannelValueComponent],
                },] }
    ];

    /*
     * Public API Surface of channel-value
     */

    /** This service is used to manage the state of a Drawer component, responds to user behavior and input settings. */
    var DrawerService = /** @class */ (function () {
        function DrawerService() {
            this.navItemCount = 0;
            this.tempOpen = false;
            this.drawerOpenObs = new rxjs.Subject();
            this.drawerSelectObs = new rxjs.Subject();
            this.drawerActiveItemChangeObs = new rxjs.Subject();
        }
        DrawerService.prototype.hasSideBorder = function () {
            return this.sideBorder;
        };
        DrawerService.prototype.setSideBorder = function (sideBorder) {
            this.sideBorder = sideBorder;
        };
        DrawerService.prototype.isOpenOnHover = function () {
            return this.openOnHover;
        };
        DrawerService.prototype.setOpenOnHover = function (openOnHover) {
            this.openOnHover = openOnHover;
        };
        DrawerService.prototype.setDisableActiveItemParentStyles = function (disableActiveItemParentStyles) {
            this.disableActiveItemParentStyles = disableActiveItemParentStyles;
        };
        DrawerService.prototype.hasDisableActiveItemParentStyles = function () {
            return this.disableActiveItemParentStyles;
        };
        DrawerService.prototype.setDrawerTempOpen = function (open) {
            this.tempOpen = open;
            this.drawerOpenObs.next(this.isDrawerOpen());
        };
        DrawerService.prototype.setIsCondensed = function (condensed) {
            this.isCondensed = condensed;
        };
        DrawerService.prototype.setDrawerOpen = function (drawerOpen) {
            this.drawerOpen = drawerOpen;
            this.drawerOpenObs.next(this.isDrawerOpen());
        };
        DrawerService.prototype.setDisableRailTooltip = function (disableRailTooltip) {
            this.disableRailTooltip = disableRailTooltip;
        };
        DrawerService.prototype.isDisableRailTooltip = function () {
            return this.disableRailTooltip;
        };
        DrawerService.prototype.setDrawerVariant = function (variant) {
            this.variant = variant;
            this.drawerOpenObs.next(this.isDrawerOpen());
        };
        DrawerService.prototype.getDrawerVariant = function () {
            return this.variant;
        };
        DrawerService.prototype.isDrawerOpen = function () {
            return (this.drawerOpen ||
                this.getDrawerVariant() === 'permanent' ||
                this.tempOpen ||
                this.getDrawerVariant() === 'rail');
        };
        DrawerService.prototype.isTempOpen = function () {
            return this.tempOpen;
        };
        DrawerService.prototype.isRailCondensed = function () {
            return this.isCondensed;
        };
        DrawerService.prototype.drawerOpenChanges = function () {
            return this.drawerOpenObs;
        };
        DrawerService.prototype.select = function (hasChildren) {
            this.drawerSelectObs.next(hasChildren);
        };
        DrawerService.prototype.drawerSelectionChanges = function () {
            return this.drawerSelectObs;
        };
        DrawerService.prototype.emitChangeActiveItemEvent = function () {
            this.drawerActiveItemChangeObs.next();
        };
        DrawerService.prototype.drawerActiveItemChanges = function () {
            return this.drawerActiveItemChangeObs;
        };
        /** Each nav item has a unique id which is used to determine which item is selected. */
        DrawerService.prototype.createNavItemID = function () {
            return ++this.navItemCount;
        };
        return DrawerService;
    }());
    DrawerService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function DrawerService_Factory() { return new DrawerService(); }, token: DrawerService, providedIn: "root" });
    DrawerService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];

    var StateListener = /** @class */ (function () {
        function StateListener(drawerService, changeDetector) {
            this.drawerService = drawerService;
            this.changeDetector = changeDetector;
        }
        StateListener.prototype.ngOnInit = function () {
            this.listenForDrawerChanges();
        };
        StateListener.prototype.ngOnDestroy = function () {
            this.unsubscribeListeners();
        };
        StateListener.prototype.isOpen = function () {
            return this.drawerService.isDrawerOpen();
        };
        StateListener.prototype.isOpenOnHover = function () {
            return this.drawerService.isOpenOnHover();
        };
        StateListener.prototype.unsubscribeListeners = function () {
            if (this.drawerOpenListener) {
                this.drawerOpenListener.unsubscribe();
            }
        };
        StateListener.prototype.listenForDrawerChanges = function () {
            var _this = this;
            this.drawerOpenListener = this.drawerService.drawerOpenChanges().subscribe(function () {
                _this.changeDetector.detectChanges();
            });
        };
        return StateListener;
    }());
    StateListener.decorators = [
        { type: i0.Directive }
    ];
    StateListener.ctorParameters = function () { return [
        { type: DrawerService },
        { type: i0.ChangeDetectorRef }
    ]; };

    /**
     * The `<blui-drawer-body>` is a wrapper for the main content of the Drawer.
     * The typical use case is to display `<blui-drawer-nav-group>` elements, but custom elements (e.g., for spacing) are accepted as well.
     */
    var DrawerBodyComponent = /** @class */ (function (_super) {
        tslib.__extends(DrawerBodyComponent, _super);
        function DrawerBodyComponent(drawerService, changeDetectorRef) {
            return _super.call(this, drawerService, changeDetectorRef) || this;
        }
        return DrawerBodyComponent;
    }(StateListener));
    DrawerBodyComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-drawer-body',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <div class=\"blui-drawer-body-content\" [class.blui-drawer-body-closed]=\"!isOpen()\">\n            <ng-content></ng-content>\n        </div>\n    ",
                    host: {
                        class: 'blui-drawer-body',
                    },
                    styles: ["\n            .blui-drawer-body-content {\n                height: 100%;\n                display: flex;\n                flex-direction: column;\n            }\n            .blui-drawer-body-closed {\n                overflow: hidden;\n            }\n        "]
                },] }
    ];
    DrawerBodyComponent.ctorParameters = function () { return [
        { type: DrawerService },
        { type: i0.ChangeDetectorRef }
    ]; };

    /**
     * [DrawerNavItem Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-drawer--readme)
     *
     * The `<blui-drawer-nav-item>` is a wrapper to the `<blui-info-list-item>` that is meant to be used within a `<blui-nav-group>`.
     */
    var DrawerNavItemComponent = /** @class */ (function (_super) {
        tslib.__extends(DrawerNavItemComponent, _super);
        function DrawerNavItemComponent(drawerService, changeDetectorRef) {
            var _this = _super.call(this, drawerService, changeDetectorRef) || this;
            /** Sets the active item background shape
             *
             * `square` - Background shape takes the entire height of width of the NavItem.
             * `round` - Background shape has a rounded corner towards the end of the NavItem.
             *
             * @default square
             * */
            _this.activeItemBackgroundShape = 'square';
            /** Sets whether to show a chevron icon on the left side of a `NavItem`
             *
             * @default false
             * */
            _this.chevron = false;
            /** Whether to show a dividing line below each NavItem
             *
             * @default false
             * */
            _this.divider = false;
            /** Sets whether to show nested nav items
             *
             * @default false
             * */
            _this.expanded = false;
            /** Sets whether to hide the nav item
             *
             * @default false
             * */
            _this.hidden = false;
            /** Sets whether to show/hide Angular ripple animation effect onClick
             *
             * @default true
             * */
            _this.ripple = true;
            /** Event triggered on nav item select */
            _this.select = new i0.EventEmitter();
            _this.isEmpty = function (el) { return isEmptyView(el); };
            _this.hasChildren = false;
            _this.id = drawerService.createNavItemID();
            _this.drawerService.drawerActiveItemChanges().subscribe(function () {
                if (_this.navItemEl) {
                    _this.manageActiveItemTreeHighlight();
                }
            });
            return _this;
        }
        DrawerNavItemComponent.prototype.ngAfterContentInit = function () {
            var e_1, _a;
            var _this = this;
            if (!this.nestedNavItems) {
                return;
            }
            // If ContentChildren is self-inclusive (ng version < 9), filter self out using service-generated NavItem ID.
            this.nestedNavItems = this.nestedNavItems.filter(function (item) { return item.id !== _this.id; });
            if (!this.nestedNavItems) {
                return;
            }
            this.hasChildren = this.nestedNavItems.length >= 1;
            try {
                for (var _b = tslib.__values(this.nestedNavItems), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var nestedItem = _c.value;
                    nestedItem.setNestedDrawerDefaults();
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        DrawerNavItemComponent.prototype.ngOnChanges = function (changes) {
            if (changes.selected) {
                this.drawerService.emitChangeActiveItemEvent();
            }
        };
        DrawerNavItemComponent.prototype.isRail = function () {
            return this.drawerService.getDrawerVariant() === 'rail';
        };
        DrawerNavItemComponent.prototype.isRailCondensed = function () {
            return this.drawerService.isRailCondensed();
        };
        DrawerNavItemComponent.prototype.showTooltipOnRailHover = function () {
            return !this.drawerService.isDisableRailTooltip();
        };
        /** Whenever the selected item in the drawer state changes, we need to check to see we should apply a hierarchical highlight. */
        DrawerNavItemComponent.prototype.manageActiveItemTreeHighlight = function () {
            if (!this.navItemEl) {
                return;
            }
            this.navItemEl.nativeElement.classList.remove('blui-drawer-nav-item-active-tree');
            if (this.drawerService.hasDisableActiveItemParentStyles()) {
                return;
            }
            // Add tree highlighting for selected items
            if (this.selected && this.depth > 1) {
                var parent = this.navItemEl.nativeElement.parentNode;
                while (parent.parentNode) {
                    parent = parent.parentNode;
                    var navItem = parent.firstElementChild;
                    if (navItem.classList.contains('blui-drawer-nav-item-content')) {
                        navItem.classList.add('blui-drawer-nav-item-active-tree');
                    }
                }
            }
        };
        DrawerNavItemComponent.prototype.listenForDrawerChanges = function () {
            var _this = this;
            this.drawerOpenListener = this.drawerService.drawerOpenChanges().subscribe(function () {
                // Two detections are required to get the custom icons to work.
                // First tick causes the icons to container to reappear.
                // Second tick handles isEmpty function calls.
                _this.changeDetector.detectChanges();
                _this.changeDetector.detectChanges();
            });
        };
        DrawerNavItemComponent.prototype.incrementDepth = function (parentDepth) {
            var e_2, _a;
            this.depth = parentDepth + 1;
            this.changeDetector.detectChanges();
            if (this.nestedNavItems) {
                try {
                    for (var _b = tslib.__values(this.nestedNavItems), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var nestedItem = _c.value;
                        nestedItem.incrementDepth(this.depth);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        };
        /** Sets default state values for non-nested nav items. */
        DrawerNavItemComponent.prototype.setNavItemDefaults = function () {
            if (this.divider === undefined)
                this.divider = true;
            if (this.hidePadding === undefined)
                this.hidePadding = true;
            this.incrementDepth(0);
        };
        /** Sets default state values for nested nav items. */
        DrawerNavItemComponent.prototype.setNestedDrawerDefaults = function () {
            this.isNestedItem = true;
            if (this.divider === undefined)
                this.divider = false;
            if (this.hidePadding === undefined)
                this.hidePadding = false;
        };
        DrawerNavItemComponent.prototype.selectItem = function () {
            this.drawerService.select(this.hasChildren);
            this.select.emit();
            if (this.hasChildren) {
                this.toggleNestedNavItems();
                this.changeDetector.detectChanges();
            }
        };
        DrawerNavItemComponent.prototype.toggleNestedNavItems = function () {
            this.expanded = !this.expanded;
        };
        return DrawerNavItemComponent;
    }(StateListener));
    DrawerNavItemComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-drawer-nav-item',
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <ng-container *ngIf=\"!hidden\">\n            <ng-template #navIcon><ng-content select=\"[blui-icon]\"></ng-content></ng-template>\n            <div\n                class=\"blui-drawer-nav-item-content\"\n                #navItem\n                matRipple\n                [class.blui-drawer-nav-item-active]=\"selected\"\n                [class.blui-drawer-nav-item-compact]=\"false\"\n            >\n                <div\n                    [class.blui-drawer-nav-item-active-highlight]=\"selected\"\n                    [class.blui-drawer-nav-item-active-round]=\"\n                        activeItemBackgroundShape === 'round' && isOpen() && !isRail()\n                    \"\n                    [class.blui-drawer-nav-item-active-square]=\"\n                        activeItemBackgroundShape === 'square' || !isOpen() || isRail()\n                    \"\n                ></div>\n                <blui-info-list-item\n                    *ngIf=\"!isRail()\"\n                    (click)=\"selectItem()\"\n                    [dense]=\"true\"\n                    [statusColor]=\"statusColor\"\n                    [chevron]=\"chevron && isOpen()\"\n                    [hidePadding]=\"hidePadding\"\n                    [divider]=\"divider ? 'full' : undefined\"\n                    [class.blui-drawer-nav-item-no-icon-closed]=\"isEmpty(iconEl) && !isOpen()\"\n                    [matTooltip]=\"title\"\n                    [matTooltipDisabled]=\"isOpen() || isOpenOnHover() || !showTooltipOnRailHover()\"\n                    matTooltipPosition=\"right\"\n                >\n                    <ng-container blui-icon #icon>\n                        <ng-container *ngTemplateOutlet=\"navIcon\"></ng-container>\n                    </ng-container>\n                    <div\n                        blui-title\n                        [class.blui-drawer-nav-item-depth-1]=\"depth === 1\"\n                        [class.blui-drawer-nav-item-depth-2]=\"depth === 2\"\n                        [class.blui-drawer-nav-item-depth-3]=\"depth === 3\"\n                    >\n                        {{ title }}\n                    </div>\n                    <div blui-subtitle>{{ subtitle }}</div>\n                    <div blui-right-content *ngIf=\"hasChildren && isOpen()\">\n                        <div #expandIcon *ngIf=\"!expanded\">\n                            <ng-content select=\"[blui-expand-icon]\"></ng-content>\n                        </div>\n                        <div #collapseIcon *ngIf=\"expanded\">\n                            <ng-content select=\"[blui-collapse-icon]\"></ng-content>\n                        </div>\n                        <mat-icon\n                            *ngIf=\"isEmpty(collapseIconEl) && isEmpty(expandIconEl)\"\n                            class=\"blui-drawer-nav-item-expand-icon\"\n                            [class.blui-drawer-nav-item-expanded]=\"expanded\"\n                            >{{ depth > 1 ? 'arrow_drop_down' : 'expand_more' }}</mat-icon\n                        >\n                    </div>\n                </blui-info-list-item>\n                <div class=\"blui-drawer-nav-item-rail-container\" *ngIf=\"isRail()\">\n                    <div\n                        (click)=\"selectItem()\"\n                        class=\"blui-drawer-nav-item-rail\"\n                        [matTooltip]=\"showTooltipOnRailHover() ? title : ''\"\n                        [matTooltipDisabled]=\"!isRailCondensed()\"\n                        matTooltipPosition=\"right\"\n                    >\n                        <ng-container *ngTemplateOutlet=\"navIcon\"></ng-container>\n                        <div class=\"blui-drawer-nav-item-rail-text\">{{ title }}</div>\n                    </div>\n                    <mat-divider *ngIf=\"divider\"></mat-divider>\n                </div>\n            </div>\n            <!-- Nested Nav Items -->\n            <mat-accordion displayMode=\"flat\" class=\"blui-drawer-nested-nav-item\" *ngIf=\"!isRail()\">\n                <mat-expansion-panel [expanded]=\"expanded && isOpen()\">\n                    <ng-content select=\"blui-drawer-nav-item\"></ng-content>\n                </mat-expansion-panel>\n            </mat-accordion>\n        </ng-container>\n    ",
                    host: {
                        class: 'blui-drawer-nav-item',
                    },
                    styles: ["[dir=rtl] .blui-drawer-nav-item-content .blui-drawer-nav-item-active-highlight{right:0}[dir=rtl] .blui-drawer-nav-item-content .blui-drawer-nav-item-active-highlight.blui-drawer-nav-item-active-round{border-radius:1.5rem 0 0 1.5rem}[dir=rtl] .blui-drawer-nav-item-content .blui-drawer-nav-item-depth-3{padding-left:0;padding-right:32px}[dir=rtl] .blui-drawer-nav-item-content blui-info-list-item.blui-drawer-nav-item-no-icon-closed .blui-info-list-item .mat-list-item-content{padding-right:16px;padding-left:24px}blui-drawer-nav-item{outline:none}blui-drawer-nav-item .blui-drawer-nav-item-active .mat-list-item:hover{background:unset}.blui-drawer-condensed-rail .blui-drawer-nav-item-content .blui-drawer-nav-item-rail{min-height:3.5rem}.blui-drawer-condensed-rail .blui-drawer-nav-item-content .blui-drawer-nav-item-rail .blui-drawer-nav-item-rail-text{display:none}.blui-drawer-nav-item-content{overflow:hidden;position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.blui-drawer-nav-item-content.blui-drawer-nav-item-compact{margin-top:.5rem;margin-bottom:.5rem}.blui-drawer-nav-item-content.blui-drawer-nav-item-compact .blui-info-list-item-content.blui-info-list-item-dense,.blui-drawer-nav-item-content.blui-drawer-nav-item-compact .blui-info-list-item-content .mat-list-item-content{height:2.5rem!important}.blui-drawer-nav-item-content .blui-drawer-nav-item-depth-1{padding-left:0}.blui-drawer-nav-item-content .blui-drawer-nav-item-depth-2{padding-left:0}.blui-drawer-nav-item-content .blui-drawer-nav-item-depth-3{padding-left:32px}.blui-drawer-nav-item-content .blui-info-list-item .mat-list-item.blui-info-list-item-content .mat-list-text .blui-info-list-item-title-wrapper{font-weight:400}.blui-drawer-nav-item-content.blui-drawer-nav-item-active .blui-info-list-item .mat-list-item.blui-info-list-item-content .mat-list-text .blui-info-list-item-title-wrapper,.blui-drawer-nav-item-content.blui-drawer-nav-item-active-tree .blui-info-list-item .mat-list-item.blui-info-list-item-content .mat-list-text .blui-info-list-item-title-wrapper{font-weight:600}.blui-drawer-nav-item-content blui-info-list-item{display:flex;flex-direction:column}.blui-drawer-nav-item-content blui-info-list-item mat-list-item{z-index:1}.blui-drawer-nav-item-content blui-info-list-item.blui-drawer-nav-item-no-icon-closed .blui-info-list-item .mat-list-item-content{padding-right:24px}.blui-drawer-nav-item-content .blui-info-list-item .blui-info-list-item-icon-wrapper{padding:0}.blui-drawer-nav-item-content .blui-drawer-nav-item-active-highlight{display:flex;z-index:0;position:absolute;height:100%;left:0;top:0}.blui-drawer-nav-item-content .blui-drawer-nav-item-active-highlight.blui-drawer-nav-item-active-round{width:calc(100% - .5rem);border-radius:0 1.5rem 1.5rem 0}.blui-drawer-nav-item-content .blui-drawer-nav-item-active-highlight.blui-drawer-nav-item-active-square{border-radius:0;width:100%}.blui-drawer-nav-item-content .blui-drawer-nav-item-expand-icon{transition:.3s;font-size:1.5rem;height:1.5rem;width:1.5rem}.blui-drawer-nav-item-content .blui-drawer-nav-item-expand-icon.blui-drawer-nav-item-expanded{transform:rotate(180deg)}.blui-drawer-nav-item-content .blui-drawer-nav-item-rail-container{z-index:1;display:flex;flex-direction:column}.blui-drawer-nav-item-content .blui-drawer-nav-item-rail-container .mat-icon{font-size:1.5rem;height:1.5rem;width:1.5rem}.blui-drawer-nav-item-content .blui-drawer-nav-item-rail{z-index:1;display:flex;flex-direction:column;min-height:4.5rem;width:calc(3.5rem + 16px);justify-content:center;align-items:center;padding:1rem 8px;box-sizing:border-box;cursor:pointer;text-align:center}.blui-drawer-nav-item-content .blui-drawer-nav-item-rail *{z-index:1}.blui-drawer-nav-item-content .blui-drawer-nav-item-rail .blui-drawer-nav-item-rail-text{font-size:.75rem;line-height:1rem;word-break:break-word;-webkit-hyphens:auto;-ms-hyphens:auto;hyphens:auto}.blui-drawer-nested-nav-item .blui-info-list-item .mat-list-item-content{padding-left:16px}.blui-drawer-nested-nav-item .mat-expansion-panel-body{padding:0}.blui-drawer-nested-nav-item .mat-expansion-panel:not([class*=mat-elevation-z]){box-shadow:unset}.blui-drawer-nested-nav-item.mat-accordion .mat-expansion-panel:last-of-type,.blui-drawer-nested-nav-item.mat-accordion .mat-expansion-panel:first-of-type{border-radius:0}\n"]
                },] }
    ];
    DrawerNavItemComponent.ctorParameters = function () { return [
        { type: DrawerService },
        { type: i0.ChangeDetectorRef }
    ]; };
    DrawerNavItemComponent.propDecorators = {
        activeItemBackgroundShape: [{ type: i0.Input }],
        chevron: [{ type: i0.Input }],
        divider: [{ type: i0.Input }],
        expanded: [{ type: i0.Input }],
        hidePadding: [{ type: i0.Input }],
        hidden: [{ type: i0.Input }],
        ripple: [{ type: i0.Input }],
        selected: [{ type: i0.Input }],
        statusColor: [{ type: i0.Input }],
        subtitle: [{ type: i0.Input }],
        title: [{ type: i0.Input }],
        select: [{ type: i0.Output }],
        nestedNavItems: [{ type: i0.ContentChildren, args: [DrawerNavItemComponent, { descendants: false },] }],
        expandIconEl: [{ type: i0.ViewChild, args: ['expandIcon',] }],
        iconEl: [{ type: i0.ViewChild, args: ['icon',] }],
        collapseIconEl: [{ type: i0.ViewChild, args: ['collapseIcon',] }],
        navItemEl: [{ type: i0.ViewChild, args: ['navItem',] }]
    };

    /**
     * [DrawerNavGroup Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-drawer--readme)
     *
     * A `<blui-drawer-nav-group>` is used inside of the `<blui-drawer-body>` to organize links and content.
     * Each group consists of an (optional) group title and a series of NavItems.
     */
    var DrawerNavGroupComponent = /** @class */ (function (_super) {
        tslib.__extends(DrawerNavGroupComponent, _super);
        function DrawerNavGroupComponent(drawerService, changeDetectorRef) {
            var _this = _super.call(this, drawerService, changeDetectorRef) || this;
            /** Whether to show a dividing line below the title */
            _this.divider = false;
            return _this;
        }
        DrawerNavGroupComponent.prototype.ngAfterContentInit = function () {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(this.navItems), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var navItem = _c.value;
                    navItem.setNavItemDefaults();
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        return DrawerNavGroupComponent;
    }(StateListener));
    DrawerNavGroupComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-drawer-nav-group',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <div class=\"blui-drawer-nav-group-content\">\n            <div\n                *ngIf=\"title\"\n                class=\"blui-drawer-nav-group-title mat-overline\"\n                [class.blui-drawer-nav-group-title-closed]=\"!isOpen()\"\n            >\n                {{ title }}\n            </div>\n            <ng-content select=\"blui-title-content\"></ng-content>\n            <mat-divider *ngIf=\"divider\"></mat-divider>\n            <mat-nav-list>\n                <ng-content select=\"blui-drawer-nav-item\"></ng-content>\n            </mat-nav-list>\n        </div>\n    ",
                    host: {
                        class: 'blui-drawer-nav-group',
                    },
                    styles: ["\n            .blui-drawer-nav-group-content .mat-list-base {\n                font-weight: 600;\n                padding-top: 0;\n            }\n            .blui-drawer-nav-group-content .blui-drawer-nav-group-title {\n                font-weight: 600;\n                height: 3rem;\n                line-height: 3rem;\n                padding: 0 16px;\n                overflow: hidden;\n                white-space: nowrap;\n                text-overflow: ellipsis;\n                display: block;\n            }\n            .blui-drawer-nav-group-content .blui-drawer-nav-group-title-closed {\n                visibility: hidden;\n            }\n        "]
                },] }
    ];
    DrawerNavGroupComponent.ctorParameters = function () { return [
        { type: DrawerService },
        { type: i0.ChangeDetectorRef }
    ]; };
    DrawerNavGroupComponent.propDecorators = {
        divider: [{ type: i0.Input }],
        title: [{ type: i0.Input }],
        navItems: [{ type: i0.ContentChildren, args: [DrawerNavItemComponent,] }]
    };

    /**
     * [InfoListItem Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-info-list-item--readme)
     *
     * The `<blui-info-list-item>` is intended to be used in List views.
     * It positions a title as well as optional subtitle(s), icon, and status stripe.
     */
    var InfoListItemComponent = /** @class */ (function () {
        function InfoListItemComponent() {
            /** Show a colored background for the icon
             *
             * @default false
             * */
            this.avatar = false;
            /** Add a chevron icon on the right
             *
             * @default false
             * */
            this.chevron = false;
            /** Smaller height row with less padding
             *
             * @default false
             * */
            this.dense = false;
            /** Disable the list item
             *
             * @default false
             * */
            this.disabled = false;
            /** Remove left padding if no icon is used */
            this.hidePadding = false;
            /** Icon alignment when avatar is set to false. Can be `left` | `right` | `center`
             *
             * `left` - Icon appears at the `flex-start` of the icon container.
             *
             * `right` - Icon appears at the `flex-end` of the icon container.
             *
             * `center` - Icon appears at the center of the icon container.
             *
             * @default left
             * */
            this.iconAlign = 'left';
            /** When true, 3rd-line text overflow breaks onto the next line instead of using an ellipsis
             *
             * @default false
             * */
            this.wrapInfo = false;
            /** When true, 2nd-line text overflow breaks onto the next line instead of using an ellipsis
             *
             * @default false
             * */
            this.wrapSubtitle = false;
            /** When true, 1st-line text overflow breaks onto the next line instead of using an ellipsis
             *
             * @default false
             * */
            this.wrapTitle = false;
            this.isEmpty = function (el) { return isEmptyView(el); };
        }
        InfoListItemComponent.prototype.ngAfterViewInit = function () {
            var required = { selector: 'title', ref: this.titleEl };
            requireContent([required], this);
        };
        return InfoListItemComponent;
    }());
    InfoListItemComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-info-list-item',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <mat-list-item\n            class=\"blui-info-list-item-content\"\n            [class.blui-info-list-item-wrap]=\"wrapSubtitle || wrapTitle || wrapInfo\"\n            [class.blui-info-list-item-dense]=\"dense\"\n            [class.blui-info-list-item-status]=\"statusColor\"\n            [style.border-left-color]=\"statusColor\"\n            [style.border-right-color]=\"statusColor\"\n            [disabled]=\"disabled\"\n        >\n            <div\n                mat-list-icon\n                class=\"blui-info-list-item-icon-wrapper\"\n                [class.blui-info-list-item-hide-padding]=\"hidePadding\"\n                [class.blui-info-list-item-avatar]=\"avatar\"\n                [style.justify-content]=\"\n                    iconAlign === 'right' ? 'flex-end' : iconAlign === 'center' ? 'center' : 'flex-start'\n                \"\n            >\n                <ng-content select=\"[blui-icon]\"></ng-content>\n            </div>\n            <div class=\"blui-info-list-item-left-content-wrapper\">\n                <ng-content select=\"[blui-left-content]\"></ng-content>\n            </div>\n            <div\n                class=\"mat-body-1 blui-info-list-item-title-wrapper\"\n                matLine\n                [class.blui-info-list-item-wrap]=\"wrapTitle\"\n                #title\n            >\n                <ng-content select=\"[blui-title]\"></ng-content>\n            </div>\n            <div\n                class=\"mat-body-2 blui-info-list-item-subtitle-wrapper\"\n                matLine\n                [class.blui-info-list-item-wrap]=\"wrapSubtitle\"\n            >\n                <ng-content select=\"[blui-subtitle]\"></ng-content>\n            </div>\n            <div\n                class=\"mat-body-2 blui-info-list-item-info-wrapper\"\n                matLine\n                [class.blui-info-list-item-wrap]=\"wrapInfo\"\n            >\n                <ng-content select=\"[blui-info]\"></ng-content>\n            </div>\n            <blui-spacer class=\"blui-info-list-item-spacer\"></blui-spacer>\n            <div class=\"blui-info-list-item-right-content\">\n                <div #right class=\"blui-info-list-item-right-content-wrapper\">\n                    <ng-content select=\"[blui-right-content]\"></ng-content>\n                </div>\n                <mat-icon *ngIf=\"chevron && isEmpty(rightEl)\" class=\"blui-chevron\">chevron_right</mat-icon>\n            </div>\n        </mat-list-item>\n        <mat-divider\n            *ngIf=\"divider\"\n            class=\"blui-info-list-item-divider\"\n            [class.blui-info-list-item-partial-divider]=\"divider === 'partial'\"\n        >\n        </mat-divider>\n    ",
                    host: {
                        class: 'blui-info-list-item',
                    },
                    styles: [".blui-info-list-item{display:block;width:100%}[dir=rtl] .blui-info-list-item-content.blui-info-list-item-status .mat-list-item-content,[dir=rtl] .mat-list-base .mat-list-item.blui-info-list-item-content.blui-info-list-item-status .mat-list-item-content{border-right:solid 6px;border-right-color:inherit;padding-right:10px;padding-left:16px;border-left:unset}[dir=rtl] .blui-info-list-item-content .mat-list-item-content .mat-list-text,[dir=rtl] .mat-list-base .mat-list-item.blui-info-list-item-content .mat-list-item-content .mat-list-text{padding-right:0}[dir=rtl] .blui-info-list-item-content .blui-info-list-item-icon-wrapper,[dir=rtl] .mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-icon-wrapper{margin-right:0;margin-left:16px}[dir=rtl] .blui-info-list-item-content .blui-chevron,[dir=rtl] .mat-list-base .mat-list-item.blui-info-list-item-content .blui-chevron{transform:scaleX(-1)}[dir=rtl] .blui-info-list-item-content .blui-info-list-item-left-content-wrapper>*,[dir=rtl] .mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-left-content-wrapper>*{margin-left:16px;margin-right:0}[dir=rtl] .blui-info-list-item-content .blui-info-list-item-right-content,[dir=rtl] .mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-right-content{margin-right:16px;margin-left:0}[dir=rtl] mat-divider.mat-divider.blui-info-list-item-partial-divider{left:0;right:4.5rem}.blui-info-list-item-content,.mat-list-base .mat-list-item.blui-info-list-item-content{width:100%;height:inherit}.blui-info-list-item-content .mat-list-item-content,.mat-list-base .mat-list-item.blui-info-list-item-content .mat-list-item-content{display:flex;align-items:center;box-sizing:border-box;height:4.5rem;padding:.5rem 16px;width:100%}.blui-info-list-item-content .mat-list-item-content .mat-list-text,.mat-list-base .mat-list-item.blui-info-list-item-content .mat-list-item-content .mat-list-text{padding-left:0;padding-right:0}.blui-info-list-item-content.blui-info-list-item-status .mat-list-item-content,.mat-list-base .mat-list-item.blui-info-list-item-content.blui-info-list-item-status .mat-list-item-content{border-left:solid 6px;border-left-color:inherit;padding-left:10px}.blui-info-list-item-content.blui-info-list-item-dense .mat-list-item-content,.mat-list-base .mat-list-item.blui-info-list-item-content.blui-info-list-item-dense .mat-list-item-content{height:3.25rem}.blui-info-list-item-content.blui-info-list-item-wrap .mat-list-item-content,.mat-list-base .mat-list-item.blui-info-list-item-content.blui-info-list-item-wrap .mat-list-item-content{height:unset;min-height:4.5rem}.blui-info-list-item-content.blui-info-list-item-wrap.blui-info-list-item-dense .mat-list-item-content,.mat-list-base .mat-list-item.blui-info-list-item-content.blui-info-list-item-wrap.blui-info-list-item-dense .mat-list-item-content{min-height:3.25rem}.blui-info-list-item-content .blui-info-list-item-title-wrapper,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-title-wrapper{font-size:1rem;font-weight:600;line-height:1.25;margin-bottom:0}.blui-info-list-item-content .blui-info-list-item-subtitle-wrapper,.blui-info-list-item-content .blui-info-list-item-info-wrapper,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-subtitle-wrapper,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-info-wrapper{font-weight:400;line-height:1.3;font-size:.875rem}.blui-info-list-item-content .blui-info-list-item-title-wrapper *,.blui-info-list-item-content .blui-info-list-item-subtitle-wrapper *,.blui-info-list-item-content .blui-info-list-item-info-wrapper *,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-title-wrapper *,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-subtitle-wrapper *,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-info-wrapper *{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.blui-info-list-item-content .blui-info-list-item-title-wrapper.blui-info-list-item-wrap *,.blui-info-list-item-content .blui-info-list-item-subtitle-wrapper.blui-info-list-item-wrap *,.blui-info-list-item-content .blui-info-list-item-info-wrapper.blui-info-list-item-wrap *,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-title-wrapper.blui-info-list-item-wrap *,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-subtitle-wrapper.blui-info-list-item-wrap *,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-info-wrapper.blui-info-list-item-wrap *{white-space:normal;overflow:unset;text-overflow:unset;overflow-wrap:break-word}.blui-info-list-item-content .blui-info-list-item-icon-wrapper,.blui-info-list-item-content .blui-info-list-item-left-content-wrapper,.blui-info-list-item-content .mat-list-text,.blui-info-list-item-content .blui-info-list-item-spacer,.blui-info-list-item-content .blui-info-list-item-right-content,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-icon-wrapper,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-left-content-wrapper,.mat-list-base .mat-list-item.blui-info-list-item-content .mat-list-text,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-spacer,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-right-content{display:flex}.blui-info-list-item-content .blui-info-list-item-icon-wrapper,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-icon-wrapper{order:1;width:2.5rem;min-width:2.5rem;max-width:40px;line-height:1.5rem;height:auto;margin-right:16px;padding:0}.blui-info-list-item-content .blui-info-list-item-icon-wrapper>*,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-icon-wrapper>*{font-size:1.5rem;height:1.5rem;width:1.5rem}.blui-info-list-item-content .blui-info-list-item-icon-wrapper.blui-info-list-item-hide-padding:empty,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-icon-wrapper.blui-info-list-item-hide-padding:empty{width:0;margin:0;min-width:unset}.blui-info-list-item-content .blui-info-list-item-icon-wrapper.blui-info-list-item-avatar>*,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-icon-wrapper.blui-info-list-item-avatar>*{padding:.5rem;display:flex;border-radius:50%;width:2.5rem;height:2.5rem;box-sizing:border-box}.blui-info-list-item-content .blui-info-list-item-left-content-wrapper,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-left-content-wrapper{order:2}.blui-info-list-item-content .blui-info-list-item-left-content-wrapper>*,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-left-content-wrapper>*{display:flex}.blui-info-list-item-content .blui-info-list-item-left-content-wrapper>*,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-left-content-wrapper>*{margin-right:1rem}.blui-info-list-item-content .mat-list-text,.mat-list-base .mat-list-item.blui-info-list-item-content .mat-list-text{order:3;overflow:hidden;flex-direction:column}.blui-info-list-item-content .blui-info-list-item-spacer,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-spacer{order:4}.blui-info-list-item-content .blui-info-list-item-right-content,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-right-content{order:5;white-space:nowrap;align-items:center;margin-left:16px}.blui-info-list-item-content .blui-info-list-item-right-content .blui-info-list-item-right-content-wrapper>*,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-right-content .blui-info-list-item-right-content-wrapper>*{display:flex;align-items:center}.blui-info-list-item-content .blui-chevron,.mat-list-base .mat-list-item.blui-info-list-item-content .blui-chevron{font-size:1.5rem;height:1.5rem;width:1.5rem}mat-divider.blui-info-list-item-divider{margin-top:-1px}mat-divider.mat-divider.blui-info-list-item-partial-divider{position:relative;bottom:0;right:0;left:calc(2.5rem + 32px);width:calc(100% - calc(2.5rem + 32px))}\n"]
                },] }
    ];
    InfoListItemComponent.propDecorators = {
        avatar: [{ type: i0.Input }],
        chevron: [{ type: i0.Input }],
        dense: [{ type: i0.Input }],
        divider: [{ type: i0.Input }],
        disabled: [{ type: i0.Input }],
        hidePadding: [{ type: i0.Input }],
        iconAlign: [{ type: i0.Input }],
        statusColor: [{ type: i0.Input }],
        wrapInfo: [{ type: i0.Input }],
        wrapSubtitle: [{ type: i0.Input }],
        wrapTitle: [{ type: i0.Input }],
        titleEl: [{ type: i0.ViewChild, args: ['title',] }],
        rightEl: [{ type: i0.ViewChild, args: ['right',] }]
    };

    var InfoListItemModule = /** @class */ (function () {
        function InfoListItemModule() {
        }
        return InfoListItemModule;
    }());
    InfoListItemModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [InfoListItemComponent],
                    imports: [SpacerModule, icon.MatIconModule, common.CommonModule, list.MatListModule, divider.MatDividerModule],
                    exports: [InfoListItemComponent, icon.MatIconModule, list.MatListModule, SpacerModule, divider.MatDividerModule],
                },] }
    ];

    /*
     * Public API Surface of Info List Item
     */

    var DrawerNavGroupModule = /** @class */ (function () {
        function DrawerNavGroupModule() {
        }
        return DrawerNavGroupModule;
    }());
    DrawerNavGroupModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [DrawerNavGroupComponent],
                    imports: [common.CommonModule, divider.MatDividerModule, list.MatListModule],
                    exports: [DrawerNavGroupComponent],
                },] }
    ];

    var DrawerNavItemModule = /** @class */ (function () {
        function DrawerNavItemModule() {
        }
        return DrawerNavItemModule;
    }());
    DrawerNavItemModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [DrawerNavItemComponent],
                    imports: [
                        tooltip.MatTooltipModule,
                        common.CommonModule,
                        InfoListItemModule,
                        icon.MatIconModule,
                        divider.MatDividerModule,
                        core.MatRippleModule,
                        expansion.MatExpansionModule,
                    ],
                    exports: [DrawerNavItemComponent],
                },] }
    ];

    var DrawerBodyModule = /** @class */ (function () {
        function DrawerBodyModule() {
        }
        return DrawerBodyModule;
    }());
    DrawerBodyModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [DrawerBodyComponent],
                    imports: [common.CommonModule, InfoListItemModule, DrawerNavGroupModule, DrawerNavItemModule],
                    exports: [
                        DrawerBodyComponent,
                        DrawerNavGroupComponent,
                        InfoListItemModule,
                        DrawerNavGroupModule,
                        DrawerNavItemModule,
                    ],
                },] }
    ];

    /**
     * [DrawerFooter Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-drawer--readme)
     *
     * The `<blui-drawer-footer>` is an optional section that renders at the bottom of the `<blui-drawer>`.
     * It can be used to add any custom content (as children).
     */
    var DrawerFooterComponent = /** @class */ (function (_super) {
        tslib.__extends(DrawerFooterComponent, _super);
        function DrawerFooterComponent(drawerService, changeDetectorRef) {
            var _this = _super.call(this, drawerService, changeDetectorRef) || this;
            /** Whether to show a dividing line above the Footer
             *
             * @default true
             * */
            _this.divider = true;
            /** Hide footer content when closed
             *
             * @default true
             * */
            _this.hideContentOnCollapse = true;
            return _this;
        }
        return DrawerFooterComponent;
    }(StateListener));
    DrawerFooterComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-drawer-footer',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <div\n            class=\"blui-drawer-footer-content\"\n            [style.visibility]=\"hideContentOnCollapse ? (isOpen() ? 'visible' : 'hidden') : 'visible'\"\n        >\n            <mat-divider *ngIf=\"divider\"></mat-divider>\n            <ng-content></ng-content>\n        </div>\n    ",
                    host: {
                        class: 'blui-drawer-footer',
                    },
                    styles: [".blui-drawer-footer-content{display:flex;flex-direction:column;overflow:hidden}\n"]
                },] }
    ];
    DrawerFooterComponent.ctorParameters = function () { return [
        { type: DrawerService },
        { type: i0.ChangeDetectorRef }
    ]; };
    DrawerFooterComponent.propDecorators = {
        divider: [{ type: i0.Input }],
        hideContentOnCollapse: [{ type: i0.Input }]
    };

    var DrawerFooterModule = /** @class */ (function () {
        function DrawerFooterModule() {
        }
        return DrawerFooterModule;
    }());
    DrawerFooterModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [DrawerFooterComponent],
                    imports: [common.CommonModule, divider.MatDividerModule],
                    exports: [DrawerFooterComponent],
                },] }
    ];

    /**
     * [DrawerHeader Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-drawer--readme)
     *
     * The `<blui-drawer-header>` contains the content found at the top of the `<blui-drawer>`.
     */
    var DrawerHeaderComponent = /** @class */ (function (_super) {
        tslib.__extends(DrawerHeaderComponent, _super);
        function DrawerHeaderComponent(drawerService, changeDetectorRef) {
            var _this = _super.call(this, drawerService, changeDetectorRef) || this;
            /** Mat toolbar color variant
             *
             * @default primary
             * */
            _this.color = 'primary';
            /** Show a divider below footer
             *
             * @default false
             * */
            _this.divider = false;
            _this.isEmpty = function (el) { return isEmptyView(el); };
            return _this;
        }
        DrawerHeaderComponent.prototype.isRail = function () {
            return this.drawerService.getDrawerVariant() === 'rail';
        };
        return DrawerHeaderComponent;
    }(StateListener));
    DrawerHeaderComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-drawer-header',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <mat-toolbar\n            class=\"blui-drawer-header-content\"\n            [class.rail]=\"isRail()\"\n            [color]=\"color\"\n            [class.blui-drawer-header-no-icon]=\"isEmpty(iconEl)\"\n        >\n            <div class=\"blui-drawer-header-background\"></div>\n            <div class=\"blui-drawer-header-text\">\n                <div #icon class=\"blui-drawer-header-icon-wrapper\">\n                    <ng-content select=\"[blui-icon]\"></ng-content>\n                </div>\n                <div *ngIf=\"title\" class=\"blui-drawer-header-title-wrapper\">\n                    <div class=\"blui-drawer-header-title\">{{ title }}</div>\n                    <div *ngIf=\"subtitle\" class=\"blui-drawer-header-subtitle mat-subheading-2\">{{ subtitle }}</div>\n                </div>\n                <ng-content select=\"[blui-title-content]\"></ng-content>\n            </div>\n        </mat-toolbar>\n        <mat-divider *ngIf=\"divider\"></mat-divider>\n    ",
                    host: {
                        class: 'blui-drawer-header',
                    },
                    styles: ["[dir=rtl] .blui-drawer-header-content .blui-drawer-header-icon-wrapper{margin-right:-.5rem;margin-left:calc(24px + (1rem - 16px) / 2)}[dir=rtl] .blui-drawer-header-content.blui-drawer-header-no-icon .blui-drawer-header-icon-wrapper{margin-right:0;margin-left:0}.blui-drawer-header-content{width:100%;align-items:flex-start;box-sizing:border-box;position:relative;overflow:hidden;display:flex;height:4rem}.blui-drawer-header-content.mat-toolbar-single-row.mat-toolbar{padding-right:16px;padding-left:16px}.blui-drawer-header-content.rail.blui-drawer-header-no-icon.mat-toolbar-single-row.mat-toolbar{padding-right:0;padding-left:0}.blui-drawer-header-content .blui-drawer-header-background{position:absolute;opacity:.3;background-position:center;background-size:cover;pointer-events:none;top:0;left:0;right:0;bottom:0}.blui-drawer-header-content .blui-drawer-header-text{z-index:2;display:flex;width:100%;height:100%}.blui-drawer-header-content .blui-drawer-header-icon-wrapper{display:flex;align-items:center;z-index:1;margin-right:calc(24px + (1rem - 16px) / 2);margin-left:-.5rem;width:2.5rem}.blui-drawer-header-content .blui-drawer-header-icon-wrapper .mat-icon-button{height:2.5rem;width:2.5rem;line-height:2.5rem}.blui-drawer-header-content .blui-drawer-header-icon-wrapper .mat-icon-button .mat-icon{font-size:1.5rem;height:1.5rem;width:1.5rem;height:unset}.blui-drawer-header-content .blui-drawer-header-icon-wrapper:empty{width:0;margin:0}.blui-drawer-header-content.blui-drawer-header-no-icon .blui-drawer-header-icon-wrapper{width:0;margin:0}.blui-drawer-header-content .blui-drawer-header-title-wrapper{display:flex;justify-content:center;align-self:stretch;flex-direction:column;width:calc(100% - 3.5rem);box-sizing:border-box;z-index:1}.blui-drawer-header-content .blui-drawer-header-title-wrapper .blui-drawer-header-title{font-weight:600;line-height:1.6rem;overflow:hidden;text-overflow:ellipsis}.blui-drawer-header-content .blui-drawer-header-title-wrapper .blui-drawer-header-subtitle{font-weight:300;line-height:1.3rem;margin-top:-.125rem;overflow:hidden;text-overflow:ellipsis}.blui-drawer-header-content .blui-drawer-header-title-wrapper .blui-drawer-header-subtitle.mat-subheading-2{margin-bottom:0}@media (max-width: 599px){.blui-drawer-header-content{height:3.5rem}}\n"]
                },] }
    ];
    DrawerHeaderComponent.ctorParameters = function () { return [
        { type: DrawerService },
        { type: i0.ChangeDetectorRef }
    ]; };
    DrawerHeaderComponent.propDecorators = {
        color: [{ type: i0.Input }],
        divider: [{ type: i0.Input }],
        subtitle: [{ type: i0.Input }],
        title: [{ type: i0.Input }],
        iconEl: [{ type: i0.ViewChild, args: ['icon', { static: true },] }]
    };

    var DrawerHeaderModule = /** @class */ (function () {
        function DrawerHeaderModule() {
        }
        return DrawerHeaderModule;
    }());
    DrawerHeaderModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [DrawerHeaderComponent],
                    imports: [common.CommonModule, toolbar.MatToolbarModule, divider.MatDividerModule],
                    exports: [DrawerHeaderComponent],
                },] }
    ];

    /**
     * [DrawerLayout Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-drawer--readme)
     *
     * The `<blui-drawer-layout>` component is a wrapper around the [Angular Material Sidenav](https://material.angular.io/components/sidenav/overview) that adds specific Brightlayer UI functionality and styling.
     * The `<blui-drawer-layout>` component is used to provide the appropriate resizing behavior for your main application content when used in conjunction with a Brightlayer UI `<blui-drawer>`.
     * It accepts a drawer and content as child elements;
     */
    var DrawerLayoutComponent = /** @class */ (function (_super) {
        tslib.__extends(DrawerLayoutComponent, _super);
        function DrawerLayoutComponent(drawerService, changeDetectorRef, _dir) {
            var _this = _super.call(this, drawerService, changeDetectorRef) || this;
            _this._dir = _dir;
            /** Controls how the Drawer behaves and appears on the screen.  Can be `permanent` | `peristent` | `temporary` | `rail`.
             *
             * `permanent` - `Drawer` appears on the side of the screen and cannot be dismissed.
             *
             * `persistent` - `Drawer` appears on the side of the screen and responds to the `open` @Input. When closed, only shows each `NavItem` icon.
             *
             * `temporary` - `Drawer` slides in from the side of the screen and appears as an overlay.
             *
             * `rail` - `Drawer` appears on the side of the screen as a slim element, supporting icons and text.
             *
             * @default temporary
             * */
            _this.variant = 'temporary';
            /** Drawer pixel width
             *
             * @default 350
             * */
            _this.width = 350;
            /** Event triggered on 'temporary' variant backdrop click */
            _this.backdropClick = new i0.EventEmitter();
            _this.isRtl = false;
            _this.dirChangeSubscription = rxjs.Subscription.EMPTY;
            _this.dirChangeSubscription = _dir.change.subscribe(function (direction) {
                _this.isRtl = direction === 'rtl';
                changeDetectorRef.detectChanges();
            });
            return _this;
        }
        DrawerLayoutComponent.prototype.ngAfterViewInit = function () {
            this.isRtl = this._dir.value === 'rtl';
        };
        DrawerLayoutComponent.prototype.ngOnChanges = function () {
            this.drawerService.setDrawerVariant(this.variant);
            this.changeDetector.detectChanges();
        };
        DrawerLayoutComponent.prototype.ngOnDestroy = function () {
            this.unsubscribeListeners();
            this.dirChangeSubscription.unsubscribe();
        };
        DrawerLayoutComponent.prototype.getMode = function () {
            return this.variant === 'temporary' ? 'over' : 'side';
        };
        DrawerLayoutComponent.prototype.toRem = function (px) {
            if (this.remElement && this.remElement.nativeElement) {
                var style = getComputedStyle(this.remElement.nativeElement);
                this.remSizePx = Number(style.fontSize.split('px')[0]);
            }
            return px / (this.remSizePx || 16);
        };
        DrawerLayoutComponent.prototype.hasSideBorder = function () {
            return this.drawerService.hasSideBorder();
        };
        DrawerLayoutComponent.prototype.closeDrawer = function () {
            this.drawerService.setDrawerOpen(false);
            this.backdropClick.emit();
        };
        // Is the drawer seen on the screen and expanded.
        DrawerLayoutComponent.prototype.isDrawerVisible = function () {
            if (this.variant === 'temporary')
                return this.isOpen();
            return true;
        };
        DrawerLayoutComponent.prototype.getContentMargin = function () {
            if (this.variant === 'temporary') {
                return 0;
            }
            return this.isCollapsed() ? this.getCollapsedWidth() : this.toRem(this.width);
        };
        DrawerLayoutComponent.prototype.getCollapsedWidth = function () {
            return this.variant === 'rail' && !this.drawerService.isRailCondensed()
                ? 3.5 + this.toRem(16) // Rail (default)
                : 1.5 + this.toRem(32); //  Rail (condensed) || closed persistent
        };
        // Is the drawer condensed.
        DrawerLayoutComponent.prototype.isCollapsed = function () {
            if (this.variant === 'rail')
                return true; // Rail is always collapsed.
            if (this.variant === 'persistent')
                return !this.isOpen();
            return false;
        };
        return DrawerLayoutComponent;
    }(StateListener));
    DrawerLayoutComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-drawer-layout',
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <mat-sidenav-container class=\"blui-drawer-layout-content\" (backdropClick)=\"closeDrawer()\" autosize=\"false\">\n            <mat-sidenav\n                class=\"blui-drawer-layout-sidenav\"\n                [fixedInViewport]=\"false\"\n                [class.blui-drawer-layout-smooth]=\"variant !== 'temporary'\"\n                [class.mat-elevation-z6]=\"!hasSideBorder()\"\n                [style.width.rem]=\"isCollapsed() ? getCollapsedWidth() : toRem(width)\"\n                [mode]=\"getMode()\"\n                [opened]=\"isDrawerVisible()\"\n            >\n                <ng-content select=\"[blui-drawer]\"></ng-content>\n            </mat-sidenav>\n            <div\n                class=\"blui-drawer-layout-nav-content\"\n                [class.blui-drawer-layout-smooth]=\"variant !== 'temporary'\"\n                [style.marginRight.rem]=\"isRtl ? getContentMargin() : 0\"\n                [style.marginLeft.rem]=\"isRtl ? 0 : getContentMargin()\"\n            >\n                <ng-content select=\"[blui-content]\"></ng-content>\n            </div>\n            <div style=\"display:none; font-size: 1rem\" #remElement></div>\n        </mat-sidenav-container>\n    ",
                    host: {
                        class: 'blui-drawer-layout',
                    },
                    styles: [".blui-drawer-layout{display:flex;height:100vh}[dir=rtl] .blui-drawer-layout-content .mat-drawer-side{border-left:0}.blui-drawer-layout-content{height:100%;width:100%;transition:none;display:flex}.blui-drawer-layout-content mat-sidenav-content{margin-left:0!important;margin-right:0!important}.blui-drawer-layout-content .mat-drawer-side{border-right:none}.blui-drawer-layout-content .blui-drawer-content{transition:none;width:100%}.blui-drawer-layout-content .blui-drawer-content.blui-drawer-collapse{width:100%}.blui-drawer-layout-content .blui-drawer-layout-sidenav,.blui-drawer-layout-content .blui-drawer-layout-nav-content{min-height:100%;transition:none}.blui-drawer-layout-content .blui-drawer-layout-sidenav.blui-drawer-layout-smooth,.blui-drawer-layout-content .blui-drawer-layout-nav-content.blui-drawer-layout-smooth{transition:.3s cubic-bezier(.4,0,.2,1)}\n"]
                },] }
    ];
    DrawerLayoutComponent.ctorParameters = function () { return [
        { type: DrawerService },
        { type: i0.ChangeDetectorRef },
        { type: bidi.Directionality }
    ]; };
    DrawerLayoutComponent.propDecorators = {
        variant: [{ type: i0.Input }],
        width: [{ type: i0.Input }],
        backdropClick: [{ type: i0.Output }],
        remElement: [{ type: i0.ViewChild, args: ['remElement',] }]
    };

    var DrawerLayoutModule = /** @class */ (function () {
        function DrawerLayoutModule() {
        }
        return DrawerLayoutModule;
    }());
    DrawerLayoutModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [DrawerLayoutComponent],
                    imports: [common.CommonModule, sidenav.MatSidenavModule],
                    exports: [DrawerLayoutComponent],
                },] }
    ];

    /**
     * [DrawerSubheader Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-drawer--readme)
     *
     * The `<blui-drawer-subheader>` is an optional section that renders below the header and above the body of the `<blui-drawer>`.
     * It can be used to support custom content (passed as children), such as filtering options or to display additional information.
     */
    var DrawerSubheaderComponent = /** @class */ (function (_super) {
        tslib.__extends(DrawerSubheaderComponent, _super);
        function DrawerSubheaderComponent(drawerService, changeDetectorRef) {
            var _this = _super.call(this, drawerService, changeDetectorRef) || this;
            /** Whether to show a dividing line below the SubHeader
             *
             * @default true
             * */
            _this.divider = true;
            /** Hide subheader content when drawer is collapsed
             *
             * @default true
             * */
            _this.hideContentOnCollapse = true;
            return _this;
        }
        return DrawerSubheaderComponent;
    }(StateListener));
    DrawerSubheaderComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-drawer-subheader',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <div\n            class=\"blui-drawer-subheader-content\"\n            [style.visibility]=\"hideContentOnCollapse ? (isOpen() ? 'visible' : 'hidden') : 'visible'\"\n        >\n            <ng-content></ng-content>\n        </div>\n        <mat-divider *ngIf=\"divider\"></mat-divider>\n    ",
                    host: {
                        class: 'blui-drawer-subheader',
                    },
                    styles: [".blui-drawer-subheader-content{display:flex;box-sizing:border-box;overflow:hidden}\n"]
                },] }
    ];
    DrawerSubheaderComponent.ctorParameters = function () { return [
        { type: DrawerService },
        { type: i0.ChangeDetectorRef }
    ]; };
    DrawerSubheaderComponent.propDecorators = {
        divider: [{ type: i0.Input }],
        hideContentOnCollapse: [{ type: i0.Input }]
    };

    var DrawerSubheaderModule = /** @class */ (function () {
        function DrawerSubheaderModule() {
        }
        return DrawerSubheaderModule;
    }());
    DrawerSubheaderModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [DrawerSubheaderComponent],
                    imports: [common.CommonModule, divider.MatDividerModule],
                    exports: [DrawerSubheaderComponent],
                },] }
    ];

    /**
     * [Drawer Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-drawer--readme)
     *
     * The `<blui-drawer>` is used to organize content (typically navigation links) within a `<blui-drawer-layout>`.
     * The `<blui-drawer>` includes helper components for `<blui-drawer-header>`, `<blui-drawer-subheader>`, `<blui-drawer-body>`, `<blui-drawer-nav-group>`, `<blui-drawer-footer>`, and `<blui-drawer-layout>` to help organize the content.
     */
    var DrawerComponent = /** @class */ (function (_super) {
        tslib.__extends(DrawerComponent, _super);
        function DrawerComponent(drawerService, changeDetectorRef) {
            var _this = _super.call(this, drawerService, changeDetectorRef) || this;
            /** Enables a condensed view for the `rail` variant which removes NavItem labels and shows tooltips instead
             *
             * @default false
             * */
            _this.condensed = false;
            /** Hides tooltips on hover for the `rail` variant
             *
             * @default false
             * */
            _this.disableRailTooltip = false;
            /** If true, NavItems will not have a bold title when a child NavItem is selected
             *
             * @default false
             * */
            _this.disableActiveItemParentStyles = false;
            /** Automatically open the drawer on hover when closed (persistent variant only) */
            _this.openOnHover = true;
            /** Delay in milliseconds before a hover event opens the drawer (persistent variant only)
             *
             * @default 500
             * */
            _this.openOnHoverDelay = 500;
            /** Toggle a side border instead of shadow
             *
             * @default false
             * */
            _this.sideBorder = false;
            return _this;
        }
        DrawerComponent.prototype.ngOnInit = function () {
            this.drawerService.setDrawerOpen(this.open);
            this.listenForDrawerChanges();
            this.listenForDrawerSelection();
        };
        // This broadcasts changes to all of the drawer state listeners.
        DrawerComponent.prototype.ngOnChanges = function () {
            this.drawerService.setSideBorder(this.sideBorder);
            this.drawerService.setDrawerOpen(this.open);
            this.drawerService.setIsCondensed(this.condensed);
            this.drawerService.setDisableRailTooltip(this.disableRailTooltip);
            this.drawerService.setDisableActiveItemParentStyles(this.disableActiveItemParentStyles);
            this.drawerService.setOpenOnHover(this.openOnHover);
        };
        DrawerComponent.prototype.hoverDrawer = function () {
            var _this = this;
            if (!this.open && this.openOnHover) {
                this.hoverDelayTimeout = setTimeout(function () {
                    _this.drawerService.setDrawerTempOpen(true);
                    _this.changeDetector.detectChanges();
                }, this.openOnHoverDelay);
            }
        };
        DrawerComponent.prototype.unhoverDrawer = function () {
            if (this.openOnHover) {
                clearTimeout(this.hoverDelayTimeout);
                if (this.drawerService.isTempOpen()) {
                    this.drawerService.setDrawerTempOpen(false);
                    this.changeDetector.detectChanges();
                }
            }
        };
        // Close drawer on selection if drawer is only temporarily opened.
        // Expanding nested navitems when temporarily opened will not close the drawer.
        DrawerComponent.prototype.listenForDrawerSelection = function () {
            var _this = this;
            this.drawerSelectionListener = this.drawerService.drawerSelectionChanges().subscribe(function (hasChildren) {
                if (_this.drawerService.isTempOpen() && !hasChildren) {
                    _this.drawerService.setDrawerTempOpen(false);
                    _this.changeDetector.detectChanges();
                }
            });
        };
        DrawerComponent.prototype.isTemporaryVariant = function () {
            return this.drawerService.getDrawerVariant() === 'temporary';
        };
        return DrawerComponent;
    }(StateListener));
    DrawerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-drawer',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <div\n            class=\"blui-drawer-content\"\n            [class.blui-drawer-side-border]=\"sideBorder\"\n            [class.mat-elevation-z6]=\"!sideBorder\"\n            [class.blui-drawer-condensed-rail]=\"condensed\"\n            [class.blui-drawer-collapse]=\"!isOpen()\"\n            [class.blui-drawer-temp-variant]=\"isTemporaryVariant()\"\n        >\n            <!-- Drawer is responsible for managing the styles between the 4 subsections -->\n            <ng-content select=\"blui-drawer-header\"></ng-content>\n            <div class=\"blui-drawer-hover-area\" (mouseenter)=\"hoverDrawer()\" (mouseleave)=\"unhoverDrawer()\">\n                <ng-content select=\"blui-drawer-subheader\"></ng-content>\n                <ng-content select=\"blui-drawer-body\"></ng-content>\n                <ng-content select=\"blui-drawer-footer\"></ng-content>\n            </div>\n        </div>\n    ",
                    host: {
                        class: 'blui-drawer',
                    },
                    styles: [".blui-drawer-layout .blui-drawer-content{box-shadow:none}.blui-drawer{height:100%;display:flex}[dir=rtl] .blui-drawer-content{border-right:0}[dir=rtl] .blui-drawer-content.blui-drawer-side-border{border-left:1px solid rgba(0,0,0,.12)}[dir=rtl] .blui-drawer-content:not(.blui-drawer-side-border){border-left:0}[dir=rtl] .blui-drawer-content.temp-variant{border-left:0}.blui-drawer-content{display:flex;flex-direction:column;height:100%;width:360px;transition:width .3s cubic-bezier(.4,0,.2,1) 0ms;box-sizing:border-box}.blui-drawer-content.blui-drawer-side-border{border-right:1px solid rgba(0,0,0,.12)}.blui-drawer-content:not(.blui-drawer-side-border){border-right:0}.blui-drawer-content.blui-drawer-temp-variant{border-right:0}.blui-drawer-content.blui-drawer-collapse,.blui-drawer-content.blui-drawer-condensed-rail .blui-drawer-nav-item-content .blui-drawer-nav-item-rail{width:calc(1.5rem + 16px * 2)}.blui-drawer-content blui-drawer-subheader,.blui-drawer-content blui-drawer-body,.blui-drawer-content blui-drawer-footer{display:flex;flex-direction:column}.blui-drawer-content blui-drawer-body{height:100%;flex:1 1 0;overflow:auto}.blui-drawer-content .blui-drawer-hover-area{display:flex;flex-direction:column;height:100%}\n"]
                },] }
    ];
    DrawerComponent.ctorParameters = function () { return [
        { type: DrawerService },
        { type: i0.ChangeDetectorRef }
    ]; };
    DrawerComponent.propDecorators = {
        condensed: [{ type: i0.Input }],
        disableRailTooltip: [{ type: i0.Input }],
        disableActiveItemParentStyles: [{ type: i0.Input }],
        open: [{ type: i0.Input }],
        openOnHover: [{ type: i0.Input }],
        openOnHoverDelay: [{ type: i0.Input }],
        sideBorder: [{ type: i0.Input }]
    };

    var DrawerModule = /** @class */ (function () {
        function DrawerModule() {
        }
        return DrawerModule;
    }());
    DrawerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [DrawerComponent],
                    imports: [
                        common.CommonModule,
                        DrawerHeaderModule,
                        DrawerSubheaderModule,
                        DrawerBodyModule,
                        DrawerFooterModule,
                        DrawerLayoutModule,
                    ],
                    exports: [
                        DrawerComponent,
                        DrawerHeaderModule,
                        DrawerSubheaderModule,
                        DrawerBodyModule,
                        DrawerFooterModule,
                        DrawerLayoutModule,
                    ],
                },] }
    ];

    /**
     * [EmptyState Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-empty-state--readme)
     *
     * The `<blui-empty-state>` component can display a particular icon, text, and actions.
     * Icon components are passed as a child element with the `emptyIcon` attribute - these will typically be a Material icon, Brightlayer UI icon, or Progress Icon.
     */
    var EmptyStateComponent = /** @class */ (function () {
        function EmptyStateComponent() {
        }
        EmptyStateComponent.prototype.ngAfterViewInit = function () {
            var required = { selector: 'emptyIcon', ref: this.emptyIcon };
            requireContent([required], this);
        };
        return EmptyStateComponent;
    }());
    EmptyStateComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-empty-state',
                    template: "<div class=\"blui-empty-state-content\">\n    <div class=\"blui-empty-state-empty-icon-wrapper\" #emptyIcon>\n        <ng-content select=\"[blui-empty-icon]\"></ng-content>\n    </div>\n    <h2 class=\"blui-empty-state-title\">\n        <ng-content select=\"[blui-title]\" *ngIf=\"!title\"></ng-content>\n        {{ title }}\n    </h2>\n    <p class=\"blui-empty-state-description mat-subheading-1\">\n        <ng-content select=\"[blui-description]\" *ngIf=\"!description\"></ng-content>\n        {{ description }}\n    </p>\n    <div class=\"blui-empty-state-actions-wrapper\">\n        <ng-content select=\"[blui-actions]\"></ng-content>\n    </div>\n</div>\n",
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    host: {
                        class: 'blui-empty-state',
                    },
                    styles: [".blui-empty-state{display:flex}.blui-empty-state-content{height:100%;width:100%;display:flex;flex-direction:column;align-items:center;justify-content:center}.blui-empty-state-content .blui-empty-state-title{margin-bottom:0}.blui-empty-state-content .blui-empty-state-description{margin-bottom:1rem}.blui-empty-state-content .blui-empty-state-title,.blui-empty-state-content .blui-empty-state-description{text-align:center;font-weight:600}.blui-empty-state-content .blui-empty-state-empty-icon-wrapper{margin-bottom:1rem;line-height:1}.blui-empty-state-content .blui-empty-state-empty-icon-wrapper>*{display:block;font-size:96px;height:100%;width:100%;text-align:center}.blui-empty-state-content .blui-empty-state-actions-wrapper .mat-button-wrapper{display:flex;align-items:center}\n"]
                },] }
    ];
    EmptyStateComponent.propDecorators = {
        description: [{ type: i0.Input }],
        title: [{ type: i0.Input }],
        emptyIcon: [{ type: i0.ViewChild, args: ['emptyIcon',] }]
    };

    var EmptyStateModule = /** @class */ (function () {
        function EmptyStateModule() {
        }
        return EmptyStateModule;
    }());
    EmptyStateModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [EmptyStateComponent],
                    imports: [common.CommonModule],
                    exports: [EmptyStateComponent],
                },] }
    ];

    /*
     * Public API Surface of empty-state
     */

    /**
     * [HeroBanner Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-hero--readme)
     *
     * The `<blui-hero-banner>` component is a simple wrapper component that is used to contain `<blui-hero>`s.
     */
    var HeroBannerComponent = /** @class */ (function () {
        function HeroBannerComponent() {
            /** Whether to show the line separator
             *
             * @default false
             * */
            this.divider = false;
        }
        return HeroBannerComponent;
    }());
    HeroBannerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-hero-banner',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <div class=\"blui-hero-banner-content\">\n            <ng-content select=\"blui-hero\"></ng-content>\n        </div>\n        <mat-divider class=\"blui-hero-banner-divider\" *ngIf=\"divider\"></mat-divider>\n    ",
                    host: {
                        class: 'blui-hero-banner',
                    },
                    styles: [".blui-hero-banner{display:flex}.blui-hero-banner-content{display:flex;flex:1 1 0;align-items:center;justify-content:center}.blui-hero-banner-content blui-hero{flex:1 1 0}.blui-hero-banner-content blui-hero:nth-child(n+5){display:none}\n"]
                },] }
    ];
    HeroBannerComponent.propDecorators = {
        divider: [{ type: i0.Input }]
    };

    /**
     * [Hero Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-hero--readme)
     *
     * The `<blui-hero>` components are used to call attention to particular values that are of the most importance to the user.
     * These are typically displayed in a banner.
     */
    var HeroComponent = /** @class */ (function () {
        function HeroComponent(_ref) {
            this._ref = _ref;
            /** The size of the primary icon (10-48) */
            this.iconSize = 36;
            /** Transforms an SVG icon based on the provided `iconSize` */
            this.scaleSvgIcon = true;
            /** Show a space between the value and units for the channel, default is `auto` */
            this.unitSpace = 'auto';
        }
        HeroComponent.prototype.ngOnChanges = function () {
            requireInput(['label'], this);
            this.iSize = this.iconSize;
        };
        HeroComponent.prototype.ngAfterViewInit = function () {
            this.hasMatSvgIcon = Boolean(this.getMatSvgIcon());
            this._ref.detectChanges();
        };
        HeroComponent.prototype.ngAfterContentChecked = function () {
            this.scaleSvgIconOnChanges();
        };
        // Used to listen for changes in the primary icon content.
        // SVG icon content might be loaded post-render (fetching icon via http)
        HeroComponent.prototype.scaleSvgIconOnChanges = function () {
            if (!this.hasMatSvgIcon || !this.primaryContainer || !this.scaleSvgIcon) {
                return;
            }
            // If the primary ng-content did not change, no action required.
            var iconHtml = this.primaryContainer.nativeElement.innerHTML;
            if (iconHtml === this.iconString) {
                return;
            }
            // Update icon data.
            this.iconString = iconHtml;
            var matIcon = this.getMatSvgIcon();
            if (matIcon) {
                this.hasMatSvgIcon = true;
                var svg = matIcon.querySelector('svg');
                if (svg) {
                    svg.style.setProperty('transform', "scale(" + this.iSize / 24 + ")");
                }
            }
        };
        // Returns projected <mat-icon> with attribute [svgIcon] if it exists
        HeroComponent.prototype.getMatSvgIcon = function () {
            return this.primaryContainer.nativeElement.querySelector('div mat-icon[svgicon]');
        };
        return HeroComponent;
    }());
    HeroComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-hero',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <div class=\"blui-hero-content\">\n            <div\n                class=\"blui-hero-primary-wrapper\"\n                #primaryContainer\n                [style.backgroundColor]=\"iconBackgroundColor\"\n                [style.lineHeight.px]=\"iSize\"\n                [style.fontSize.px]=\"iSize\"\n                [style.width.px]=\"iSize\"\n                [style.height.px]=\"iSize\"\n                [class.blui-hero-svgIcon]=\"hasMatSvgIcon\"\n            >\n                <ng-content select=\"[blui-primary]\"></ng-content>\n            </div>\n            <span class=\"blui-hero-channel-value-wrapper\">\n                <ng-content select=\"blui-channel-value\" *ngIf=\"value === undefined\"></ng-content>\n                <blui-channel-value *ngIf=\"value !== undefined\" [value]=\"value\" [units]=\"units\" [unitSpace]=\"unitSpace\">\n                    <ng-content select=\"[blui-secondary]\"></ng-content>\n                </blui-channel-value>\n            </span>\n            <h5 class=\"blui-hero-label\">{{ label }}</h5>\n        </div>\n    ",
                    host: {
                        class: 'blui-hero',
                    },
                    styles: [".blui-hero{display:flex}[dir=rtl] .blui-hero-content .blui-hero-primary-wrapper{display:flex;justify-content:flex-end}.blui-hero-content{display:flex;flex:1 1 0;flex-direction:column;align-items:center;justify-content:flex-start;font-size:1rem;overflow:hidden;padding:1rem 8px}.blui-hero-content .blui-hero-primary-wrapper{border-radius:50%;margin-bottom:.5rem;text-align:center}.blui-hero-content .blui-hero-channel-value-wrapper{display:flex;font-size:1.25rem}.blui-hero-content .blui-hero-label{font-size:inherit;line-height:1.2;letter-spacing:0;font-weight:600;width:100%;text-align:center;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;margin:0}.blui-hero-content .blui-hero-primary-wrapper *{display:flex;align-items:center;justify-content:center;font-size:100%}.blui-hero-content .blui-hero-primary-wrapper:not(.blui-hero-svgIcon)>*{width:100%;height:100%}.blui-hero-content .blui-hero-primary-wrapper:not(.blui-hero-svgIcon)>* svg{width:100%;height:100%}.blui-hero-content .blui-hero-primary-wrapper.blui-hero-svgIcon svg{transform-origin:top left}\n"]
                },] }
    ];
    HeroComponent.ctorParameters = function () { return [
        { type: i0.ChangeDetectorRef }
    ]; };
    HeroComponent.propDecorators = {
        color: [{ type: i0.Input }],
        iconBackgroundColor: [{ type: i0.Input }],
        iconSize: [{ type: i0.Input }],
        label: [{ type: i0.Input }],
        scaleSvgIcon: [{ type: i0.Input }],
        units: [{ type: i0.Input }],
        value: [{ type: i0.Input }],
        unitSpace: [{ type: i0.Input }],
        primaryContainer: [{ type: i0.ViewChild, args: ['primaryContainer',] }]
    };

    var HeroModule = /** @class */ (function () {
        function HeroModule() {
        }
        return HeroModule;
    }());
    HeroModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [HeroComponent, HeroBannerComponent],
                    imports: [divider.MatDividerModule, ChannelValueModule, common.CommonModule],
                    exports: [HeroComponent, HeroBannerComponent],
                },] }
    ];

    /*
     * Public API Surface of hero
     */

    /**
     * [ScoreCard Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-score-card--readme)
     *
     `<blui-score-card>` is a card component that calls attention to particular values.
     */
    var ScoreCardComponent = /** @class */ (function () {
        function ScoreCardComponent() {
            /** Vertical offset for the badge content
             *
             * @default 0
             * */
            this.badgeOffset = 0;
        }
        ScoreCardComponent.prototype.ngOnChanges = function () {
            requireInput(['headerTitle'], this);
        };
        return ScoreCardComponent;
    }());
    ScoreCardComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-score-card',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <mat-card class=\"blui-score-card-content\">\n            <div class=\"blui-score-card-header\">\n                <div class=\"blui-score-card-header-background\"></div>\n                <div class=\"blui-score-card-header-wrapper\">\n                    <div class=\"blui-score-card-header-text\">\n                        <mat-card-title class=\"blui-score-card-title\">{{ headerTitle }}</mat-card-title>\n                        <mat-card-subtitle class=\"blui-score-card-subtitle\">{{ headerSubtitle }}</mat-card-subtitle>\n                        <mat-card-subtitle class=\"blui-score-card-info\">{{ headerInfo }}</mat-card-subtitle>\n                    </div>\n                    <div class=\"blui-score-card-action-items-wrapper\">\n                        <ng-content select=\"[blui-action-items]\"></ng-content>\n                    </div>\n                </div>\n            </div>\n            <mat-card-content>\n                <div class=\"blui-score-card-body\">\n                    <ng-content select=\"[blui-body]\"></ng-content>\n                    <div class=\"blui-score-card-badge-wrapper\" [style.marginTop.px]=\"badgeOffset || 'inherit'\">\n                        <ng-content select=\"[blui-badge]\"></ng-content>\n                    </div>\n                </div>\n                <mat-divider *ngIf=\"actionRow.childNodes.length !== 0\"></mat-divider>\n                <div class=\"blui-score-card-action-row-wrapper\" #actionRow>\n                    <ng-content select=\"[blui-action-row]\"></ng-content>\n                </div>\n            </mat-card-content>\n        </mat-card>\n    ",
                    host: {
                        class: 'blui-score-card',
                    },
                    styles: ["[dir=rtl] .blui-score-card-header .blui-score-card-action-items-wrapper>*{margin-right:0;margin-left:16px}[dir=rtl] .blui-score-card-header .blui-score-card-action-items-wrapper>:last-child{margin-left:0}.blui-score-card{display:flex}.blui-score-card-content.mat-card{display:flex;flex-direction:column;width:100%;padding:0}.blui-score-card-header{border-top-left-radius:inherit;border-top-right-radius:inherit;height:6rem;box-sizing:border-box;position:relative}.blui-score-card-header *{color:inherit;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.blui-score-card-header .blui-score-card-header-background{position:absolute;width:100%;height:100%;opacity:.3;background-position:center;background-size:cover;pointer-events:none}.blui-score-card-header .blui-score-card-header-wrapper{padding:1rem 16px 0;display:flex;justify-content:space-between}.blui-score-card-header .blui-score-card-action-items-wrapper{text-overflow:unset;overflow:unset}.blui-score-card-header .blui-score-card-action-items-wrapper>*{cursor:pointer;margin-right:16px;text-align:center;font-size:1.5rem;height:1.5rem;width:1.5rem}.blui-score-card-header .blui-score-card-action-items-wrapper>:last-child{margin-right:0}.blui-score-card-header .blui-score-card-title{font-weight:600;line-height:1;font-size:1.25rem;margin-bottom:.6rem}.blui-score-card-header .blui-score-card-subtitle{font-size:.875rem;font-weight:400;margin:0 0 .125rem;line-height:1.25}.blui-score-card-header .blui-score-card-info{font-size:.875rem;font-weight:300;line-height:2}.blui-score-card-body{display:flex;justify-content:space-between;align-items:center}.blui-score-card-body .blui-score-card-badge-wrapper{z-index:1;margin-left:16px;margin-right:16px}.blui-score-card-action-row-wrapper{cursor:pointer}\n"]
                },] }
    ];
    ScoreCardComponent.propDecorators = {
        badgeOffset: [{ type: i0.Input }],
        headerInfo: [{ type: i0.Input }],
        headerSubtitle: [{ type: i0.Input }],
        headerTitle: [{ type: i0.Input }]
    };

    var ScoreCardModule = /** @class */ (function () {
        function ScoreCardModule() {
        }
        return ScoreCardModule;
    }());
    ScoreCardModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [ScoreCardComponent],
                    imports: [common.CommonModule, card.MatCardModule, divider.MatDividerModule],
                    exports: [ScoreCardComponent],
                },] }
    ];

    /**
     * [ListItemTag Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-list-item-tag--readme)
     *
     * The `<blui-list-item-tag>` is a text item with a colored background and rounded corners that is used to tag lists.
     */
    var ListItemTagComponent = /** @class */ (function () {
        function ListItemTagComponent() {
        }
        ListItemTagComponent.prototype.ngOnChanges = function () {
            requireInput(['label'], this);
        };
        return ListItemTagComponent;
    }());
    ListItemTagComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-list-item-tag',
                    template: "<div class=\"blui-list-item-tag-content\" [style.backgroundColor]=\"backgroundColor\">\n    <div class=\"mat-small blui-list-item-tag-label\" [style.color]=\"fontColor\">\n        {{ label }}\n    </div>\n</div>\n",
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    host: {
                        class: 'blui-list-item-tag',
                    },
                    styles: [".blui-list-item-tag{display:inline-block}.blui-list-item-tag,.blui-list-item-tag-content{border-radius:.125rem}.blui-list-item-tag-content{padding:0 .25rem;overflow:hidden}.blui-list-item-tag-content .blui-list-item-tag-label{font-weight:700;text-transform:uppercase;letter-spacing:1px;margin-right:-1px;line-height:1rem;font-size:.625rem}\n"]
                },] }
    ];
    ListItemTagComponent.propDecorators = {
        backgroundColor: [{ type: i0.Input }],
        fontColor: [{ type: i0.Input }],
        label: [{ type: i0.Input }]
    };

    var ListItemTagModule = /** @class */ (function () {
        function ListItemTagModule() {
        }
        return ListItemTagModule;
    }());
    ListItemTagModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [ListItemTagComponent],
                    exports: [ListItemTagComponent],
                },] }
    ];

    /*
     * Public API Surface of List Item Tag
     */

    /**
     * [DropdownToolbar Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-dropdown-toolbar--readme)
     *
     * The `<blui-dropdown-toolbar>` component is used to display a toolbar with a dropdown.
     */
    var DropdownToolbarComponent = /** @class */ (function () {
        function DropdownToolbarComponent() {
            /** Mat toolbar color variant */
            this.color = 'primary';
        }
        return DropdownToolbarComponent;
    }());
    DropdownToolbarComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-dropdown-toolbar',
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <mat-toolbar fxLayout=\"row\" class=\"blui-dropdown-toolbar-content\" [color]=\"color\">\n            <div class=\"blui-dropdown-toolbar-icon-wrapper\">\n                <ng-content select=\"[blui-nav-icon]\"></ng-content>\n            </div>\n            <div *ngIf=\"title\" class=\"blui-dropdown-toolbar-text-content-container\">\n                <div class=\"blui-dropdown-toolbar-title mat-title\">{{ title }}</div>\n                <div\n                    *ngIf=\"subtitle\"\n                    class=\"blui-dropdown-toolbar-subtitle-container mat-subheading-2\"\n                    [matMenuTriggerFor]=\"dropdownToolbarMenu\"\n                    #menuTrigger=\"matMenuTrigger\"\n                >\n                    <span class=\"blui-dropdown-toolbar-subtitle mat-subheading-2\">{{ subtitle }}</span>\n                    <mat-icon\n                        class=\"blui-dropdown-toolbar-subtitle-icon\"\n                        [class.rotated-dropdown-arrow]=\"menuTrigger.menuOpen\"\n                        >arrow_drop_down</mat-icon\n                    >\n                </div>\n            </div>\n            <ng-content></ng-content>\n            <mat-menu\n                #dropdownToolbarMenu=\"matMenu\"\n                [overlapTrigger]=\"false\"\n                class=\"blui-dropdown-toolbar-menu-wrapper\"\n            >\n                <ng-content select=\"[blui-toolbar-menu]\"></ng-content>\n            </mat-menu>\n        </mat-toolbar>\n    ",
                    host: {
                        class: 'blui-dropdown-toolbar',
                    },
                    styles: ["[dir=rtl] .blui-dropdown-toolbar-content .blui-dropdown-toolbar-icon-wrapper>*{margin-right:-8px;margin-left:32px}[dir=rtl] .blui-dropdown-toolbar-content .blui-dropdown-toolbar-text-content-container{padding-right:0}.blui-dropdown-toolbar{display:flex}.blui-dropdown-toolbar-content{height:4rem}.blui-dropdown-toolbar-content .blui-dropdown-toolbar-icon-wrapper>*{margin-right:32px;margin-left:-8px}.blui-dropdown-toolbar-content .mat-icon-button{height:2.5rem;width:2.5rem;line-height:2.5rem}.blui-dropdown-toolbar-content .mat-icon-button .mat-icon{font-size:1.5rem;height:1.5rem;width:1.5rem;height:unset}@media (max-width: 599px){.blui-dropdown-toolbar-content{height:3.5rem}}.blui-dropdown-toolbar-text-content-container{display:block;overflow:hidden}.blui-dropdown-toolbar-text-content-container .blui-dropdown-toolbar-title{line-height:1.6rem;overflow:hidden;text-overflow:ellipsis}.blui-dropdown-toolbar-text-content-container .blui-dropdown-toolbar-subtitle-container{margin-top:-.125rem;display:flex;align-items:center;cursor:pointer}.blui-dropdown-toolbar-text-content-container .blui-dropdown-toolbar-subtitle-container .blui-dropdown-toolbar-subtitle{line-height:1.3rem;overflow:hidden;text-overflow:ellipsis}.blui-dropdown-toolbar-text-content-container .blui-dropdown-toolbar-subtitle-container .blui-dropdown-toolbar-subtitle-icon{margin:0 .25rem;font-size:1.5rem;height:1.5rem;width:1.5rem}.blui-dropdown-toolbar-text-content-container .blui-dropdown-toolbar-subtitle-container .rotated-dropdown-arrow{transform:rotate(180deg)}\n"]
                },] }
    ];
    DropdownToolbarComponent.propDecorators = {
        title: [{ type: i0.Input }],
        subtitle: [{ type: i0.Input }],
        color: [{ type: i0.Input }],
        menuTrigger: [{ type: i0.ViewChild, args: ['menuTrigger',] }]
    };

    var DropdownToolbarModule = /** @class */ (function () {
        function DropdownToolbarModule() {
        }
        return DropdownToolbarModule;
    }());
    DropdownToolbarModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [DropdownToolbarComponent],
                    imports: [
                        common.CommonModule,
                        toolbar.MatToolbarModule,
                        select.MatSelectModule,
                        formField.MatFormFieldModule,
                        icon.MatIconModule,
                        menu.MatMenuModule,
                        SpacerModule,
                    ],
                    exports: [DropdownToolbarComponent],
                },] }
    ];

    /**
     * [ThreeLiner Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-three-liner--readme)
     *
     * The `<blui-three-liner>` can display up to three lines of stylized text or other ng-content.
     * It is most commonly used within the context of a `<blui-app-bar>` component where the text can grow / shrink as the App Bar is expanded and collapsed.
     */
    var ThreeLinerComponent = /** @class */ (function () {
        function ThreeLinerComponent(_ref) {
            this._ref = _ref;
            this.isEmpty = function (el) { return isEmptyView(el); };
        }
        ThreeLinerComponent.prototype.ngAfterViewInit = function () {
            this._ref.detectChanges();
        };
        return ThreeLinerComponent;
    }());
    ThreeLinerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-three-liner',
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <div class=\"blui-three-liner-content\">\n            <div class=\"blui-three-liner-title\">\n                <div #titleVc>\n                    <ng-content select=\"[blui-title]\"></ng-content>\n                </div>\n                <ng-container *ngIf=\"isEmpty(titleEl)\">\n                    {{ title }}\n                </ng-container>\n            </div>\n\n            <div class=\"blui-three-liner-subtitle\">\n                <div #subtitleVc>\n                    <ng-content select=\"[blui-subtitle]\"></ng-content>\n                </div>\n                <ng-container *ngIf=\"isEmpty(subtitleEl)\">\n                    {{ subtitle }}\n                </ng-container>\n            </div>\n\n            <div class=\"blui-three-liner-info\">\n                <div #infoVc>\n                    <ng-content select=\"[blui-info]\"></ng-content>\n                </div>\n                <ng-container *ngIf=\"isEmpty(infoEl)\">\n                    {{ info }}\n                </ng-container>\n            </div>\n        </div>\n    ",
                    host: {
                        class: 'blui-three-liner',
                    },
                    styles: [".blui-three-liner{display:flex}.blui-three-liner-title{font-size:1.875rem;transition:all .3s}.blui-three-liner-subtitle{font-size:1rem;transition:all .3s}.blui-three-liner-info{font-size:.875rem;font-weight:300;transition:all .3s}\n"]
                },] }
    ];
    ThreeLinerComponent.ctorParameters = function () { return [
        { type: i0.ChangeDetectorRef }
    ]; };
    ThreeLinerComponent.propDecorators = {
        title: [{ type: i0.Input }],
        subtitle: [{ type: i0.Input }],
        info: [{ type: i0.Input }],
        titleEl: [{ type: i0.ViewChild, args: ['titleVc',] }],
        subtitleEl: [{ type: i0.ViewChild, args: ['subtitleVc',] }],
        infoEl: [{ type: i0.ViewChild, args: ['infoVc',] }]
    };

    var ThreeLinerModule = /** @class */ (function () {
        function ThreeLinerModule() {
        }
        return ThreeLinerModule;
    }());
    ThreeLinerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [ThreeLinerComponent],
                    imports: [common.CommonModule],
                    exports: [ThreeLinerComponent],
                },] }
    ];

    /**
     * [UserMenu Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-user-menu--readme)
     *
     * The `<blui-user-menu>` is an Avatar that opens a Menu when clicked.
     * It is typically used in the top-right corner of an application and indicates who is logged in.
     */
    var UserMenuComponent = /** @class */ (function () {
        function UserMenuComponent(_bottomSheet, _ref) {
            var _this = this;
            this._bottomSheet = _bottomSheet;
            this._ref = _ref;
            /** Where to render the menu relative to the avatar */
            this.positions = [
                new overlay.ConnectionPositionPair({ originX: 'start', originY: 'top' }, { overlayX: 'start', overlayY: 'top' }),
            ];
            /** Window pixel width at which the responsive bottom sheet menu is triggered (set to 0 to disable responsive behavior)
             *
             * @default 600
             * */
            this.useBottomSheetAt = 600;
            /** Emits event when backdrop is clicked */
            this.backdropClick = new i0.EventEmitter();
            /** Emits an event when the open prop changes */
            this.openChange = new i0.EventEmitter();
            this.checkScreenSize = function () { return document.body.offsetWidth < _this.useBottomSheetAt; };
        }
        UserMenuComponent.prototype.ngOnInit = function () {
            var _this = this;
            requireInput(['open'], this);
            // Subscribe to resize events and transition from menu to bottomsheet (or vise versa) when open & resizing
            this.screenSizeChangeListener = rxjs.fromEvent(window, 'resize')
                .pipe(operators.map(this.checkScreenSize))
                .pipe(operators.startWith(this.checkScreenSize()))
                .subscribe(function (isMobile) {
                // Transition from Desktop to Mobile
                if (_this.open && isMobile && !_this.useBottomSheet) {
                    _this.isMenuOpen = false;
                    _this.openBottomSheet();
                    _this._ref.detectChanges();
                }
                // Transition from Mobile to Desktop
                else if (_this.open && !isMobile && _this.useBottomSheet) {
                    _this._bottomSheet.dismiss(true);
                }
                _this.useBottomSheet = isMobile;
            });
        };
        UserMenuComponent.prototype.ngOnChanges = function (changes) {
            // Set state and dismiss bottom sheet when open() changes.
            if (changes.open) {
                // State changes from closed to open.
                var openState = changes.open;
                if (openState.currentValue === true && (openState.previousValue === false || openState.isFirstChange())) {
                    if (this.useBottomSheet) {
                        this.openBottomSheet();
                    }
                    else {
                        this.isMenuOpen = true;
                    }
                }
                // State changes from open to closed.
                if (openState.currentValue === false && (openState.previousValue === true || openState.isFirstChange())) {
                    this.isMenuOpen = false;
                    this._bottomSheet.dismiss(false);
                }
            }
            if (changes.useBottomSheetAt) {
                this.useBottomSheet = this.checkScreenSize();
            }
        };
        UserMenuComponent.prototype.ngOnDestroy = function () {
            if (this.screenSizeChangeListener) {
                this.screenSizeChangeListener.unsubscribe();
            }
        };
        UserMenuComponent.prototype.onClickMenuBackdrop = function () {
            this.openChange.emit(false);
            this.backdropClick.emit();
        };
        UserMenuComponent.prototype.openOverlay = function () {
            this.openChange.emit(true);
        };
        UserMenuComponent.prototype.openBottomSheet = function () {
            var _this = this;
            // Do not invoke the bottom sheet until `menu` has been rendered.
            this._ref.detectChanges();
            var bottomSheetRef = this._bottomSheet.open(this.menu, {
                backdropClass: 'blui-user-menu-bottomsheet-backdrop',
                panelClass: 'blui-user-menu-bottomsheet',
                hasBackdrop: true,
            });
            bottomSheetRef.afterDismissed().subscribe(function (openMenu) {
                _this.isMenuOpen = openMenu;
                _this._ref.detectChanges();
            });
            bottomSheetRef.backdropClick().subscribe(function () {
                _this.openChange.emit(false);
                _this.backdropClick.emit();
            });
        };
        return UserMenuComponent;
    }());
    UserMenuComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-user-menu',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    animations: [
                        animations.trigger('fade-in-out', [
                            animations.state('*', animations.style({ opacity: 1, transform: 'scaleY(1)', 'transform-origin': 'top' })),
                            // Create
                            animations.transition('void => *', [
                                animations.style({ opacity: 0, transform: 'scaleY(0.9)', 'transform-origin': 'top' }),
                                animations.animate('120ms cubic-bezier(0, 0, 0.2, 1)'),
                            ]),
                            // Destroy
                            animations.transition('* => void', animations.animate('100ms 25ms linear', animations.style({ opacity: 0 }))),
                        ]),
                    ],
                    template: "\n        <!-- This button triggers the overlay and is it's origin -->\n        <blui-user-menu-avatar\n            cdkOverlayOrigin\n            [avatarValue]=\"avatarValue\"\n            [avatarImage]=\"avatarImage\"\n            (click)=\"openOverlay()\"\n            #trigger=\"cdkOverlayOrigin\"\n        >\n            <ng-content select=\"[blui-avatar]\"></ng-content>\n        </blui-user-menu-avatar>\n\n        <ng-template #menu>\n            <blui-user-menu-header\n                *ngIf=\"menuTitle\"\n                class=\"blui-user-menu-header\"\n                [title]=\"menuTitle\"\n                [subtitle]=\"menuSubtitle\"\n                [divider]=\"true\"\n            >\n                <blui-user-menu-avatar\n                    blui-icon\n                    [avatarValue]=\"avatarValue\"\n                    [avatarImage]=\"avatarImage\"\n                    class=\"blui-user-menu-header-avatar\"\n                >\n                    <ng-content select=\"[blui-menu-avatar]\"></ng-content>\n                </blui-user-menu-avatar>\n            </blui-user-menu-header>\n            <ng-content select=\"[blui-menu-header]\"></ng-content>\n            <ng-content select=\"[blui-menu-body]\"></ng-content>\n        </ng-template>\n\n        <ng-template\n            cdkConnectedOverlay\n            (backdropClick)=\"onClickMenuBackdrop()\"\n            [cdkConnectedOverlayPush]=\"true\"\n            [cdkConnectedOverlayHasBackdrop]=\"true\"\n            [cdkConnectedOverlayOrigin]=\"trigger\"\n            [cdkConnectedOverlayOpen]=\"isMenuOpen\"\n            [cdkConnectedOverlayPositions]=\"positions\"\n            [cdkConnectedOverlayViewportMargin]=\"16\"\n            [cdkConnectedOverlayBackdropClass]=\"'blui-user-menu-overlay-backdrop'\"\n        >\n            <mat-card class=\"blui-user-menu-overlay mat-elevation-z8\" [@fade-in-out]>\n                <ng-template [ngTemplateOutlet]=\"menu\"></ng-template>\n            </mat-card>\n        </ng-template>\n    ",
                    host: {
                        class: 'blui-user-menu',
                    },
                    styles: [".blui-user-menu{display:flex}.blui-user-menu-avatar{display:flex;border-radius:50%}.blui-user-menu-avatar-content{height:2.5rem;width:2.5rem;line-height:2.5rem;cursor:pointer;text-align:center;display:flex;justify-content:center;align-content:center}.blui-user-menu-avatar-content img{width:100%;height:100%}.blui-user-menu-avatar-content .mat-icon{align-self:center;font-size:1.5rem;height:1.5rem;width:1.5rem}mat-card.blui-user-menu-overlay{padding:0}.blui-user-menu-text-avatar{margin-bottom:0;font-weight:400;line-height:2.5rem}.blui-user-menu-header mat-toolbar{border-top-left-radius:4px;border-top-right-radius:4px}.blui-user-menu-header mat-toolbar .blui-drawer-header-title{font-size:1rem}.blui-user-menu-header mat-toolbar .blui-drawer-header-subtitle{font-size:.875rem}.blui-user-menu-bottomsheet .blui-user-menu-header mat-toolbar{border-top-left-radius:0;border-top-right-radius:0}.cdk-overlay-backdrop-showing.blui-user-menu-overlay-backdrop{background-color:unset}.cdk-overlay-backdrop-showing.blui-user-menu-bottomsheet-backdrop{background-color:#424e54;opacity:.5}.cdk-overlay-backdrop.blui-user-menu-bottomsheet-backdrop,.cdk-overlay-backdrop.blui-user-menu-overlay-backdrop{transition:all .4s cubic-bezier(.25,.8,.25,1)}.blui-user-menu-overlay .mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-title-wrapper,.blui-user-menu-bottomsheet .mat-list-base .mat-list-item.blui-info-list-item-content .blui-info-list-item-title-wrapper{font-weight:400}.blui-user-menu-bottomsheet.mat-bottom-sheet-container{padding:0}.blui-user-menu-bottomsheet .mat-toolbar-single-row{height:4rem}\n"]
                },] }
    ];
    UserMenuComponent.ctorParameters = function () { return [
        { type: bottomSheet.MatBottomSheet },
        { type: i0.ChangeDetectorRef }
    ]; };
    UserMenuComponent.propDecorators = {
        avatarImage: [{ type: i0.Input }],
        avatarValue: [{ type: i0.Input }],
        menuSubtitle: [{ type: i0.Input }],
        menuTitle: [{ type: i0.Input }],
        positions: [{ type: i0.Input }],
        open: [{ type: i0.Input }],
        useBottomSheetAt: [{ type: i0.Input }],
        backdropClick: [{ type: i0.Output }],
        openChange: [{ type: i0.Output }],
        menu: [{ type: i0.ViewChild, args: [i0.TemplateRef,] }]
    };

    var UserMenuAvatarComponent = /** @class */ (function () {
        function UserMenuAvatarComponent() {
        }
        return UserMenuAvatarComponent;
    }());
    UserMenuAvatarComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-user-menu-avatar',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <div class=\"blui-user-menu-avatar-content\">\n            <div *ngIf=\"avatarValue\" class=\"mat-h2 blui-user-menu-text-avatar\">{{ avatarValue }}</div>\n            <img *ngIf=\"avatarImage\" [src]=\"avatarImage\" alt=\"User Menu Avatar\" />\n            <ng-content></ng-content>\n        </div>\n    ",
                    host: {
                        class: 'blui-user-menu-avatar',
                    }
                },] }
    ];
    UserMenuAvatarComponent.propDecorators = {
        avatarValue: [{ type: i0.Input }],
        avatarImage: [{ type: i0.Input }]
    };

    /**
     * [UserMenuHeaderComponent Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-user-menu--readme)
     *
     * The `<blui-user-menu-header>` is the menu header of the `<blui-user-menu>`.
     */
    var UserMenuHeaderComponent = /** @class */ (function () {
        function UserMenuHeaderComponent() {
            /** Mat toolbar color variant
             *
             * @default primary
             * */
            this.color = 'primary';
            /** Show a divider below footer
             *
             * @default false
             * */
            this.divider = false;
            this.isEmpty = function (el) { return isEmptyView(el); };
        }
        return UserMenuHeaderComponent;
    }());
    UserMenuHeaderComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-user-menu-header',
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    template: "\n        <mat-toolbar\n            class=\"blui-user-menu-header-content\"\n            [color]=\"color\"\n            [class.blui-user-menu-header-no-icon]=\"isEmpty(iconEl)\"\n        >\n            <div class=\"blui-user-menu-header-text\">\n                <div #icon class=\"blui-user-menu-header-icon-wrapper\">\n                    <ng-content select=\"[blui-icon]\"></ng-content>\n                </div>\n                <div *ngIf=\"title\" class=\"blui-user-menu-header-title-wrapper\">\n                    <div class=\"blui-user-menu-header-title\">{{ title }}</div>\n                    <div *ngIf=\"subtitle\" class=\"blui-user-menu-header-subtitle mat-subheading-2\">{{ subtitle }}</div>\n                </div>\n                <ng-content select=\"[blui-title-content]\"></ng-content>\n            </div>\n        </mat-toolbar>\n        <mat-divider *ngIf=\"divider\"></mat-divider>\n    ",
                    host: {
                        class: 'blui-user-menu-header',
                    },
                    styles: ["[dir=rtl] .blui-user-menu-header-content .blui-user-menu-header-icon-wrapper{margin-right:-.5rem;margin-left:calc(24px + (1rem - 16px) / 2)}[dir=rtl] .blui-user-menu-header-content.blui-user-menu-header-no-icon .blui-user-menu-header-icon-wrapper{margin-right:0;margin-left:0}.blui-user-menu-header-content{width:100%;align-items:flex-start;box-sizing:border-box;position:relative;overflow:hidden;display:flex;height:4rem}.blui-user-menu-header-content.mat-toolbar-single-row.mat-toolbar{padding-right:16px;padding-left:16px}.blui-user-menu-header-content .blui-user-menu-header-text{z-index:2;display:flex;width:100%;height:100%}.blui-user-menu-header-content .blui-user-menu-header-icon-wrapper{display:flex;align-items:center;z-index:1;margin-right:calc(24px + (1rem - 16px) / 2);margin-left:-.5rem;width:2.5rem}.blui-user-menu-header-content .blui-user-menu-header-icon-wrapper .mat-icon-button{height:2.5rem;width:2.5rem;line-height:2.5rem}.blui-user-menu-header-content .blui-user-menu-header-icon-wrapper .mat-icon-button .mat-icon{font-size:1.5rem;height:1.5rem;width:1.5rem;height:unset}.blui-user-menu-header-content .blui-user-menu-header-icon-wrapper:empty{width:0;margin:0}.blui-user-menu-header-content.blui-user-menu-header-no-icon .blui-user-menu-header-icon-wrapper{width:0;margin:0}.blui-user-menu-header-content .blui-user-menu-header-title-wrapper{display:flex;justify-content:center;align-self:stretch;flex-direction:column;width:calc(100% - 3.5rem);box-sizing:border-box;z-index:1}.blui-user-menu-header-content .blui-user-menu-header-title-wrapper .blui-user-menu-header-title{font-weight:600;line-height:1.6rem;overflow:hidden;text-overflow:ellipsis}.blui-user-menu-header-content .blui-user-menu-header-title-wrapper .blui-user-menu-header-subtitle{font-weight:300;line-height:1.3rem;margin-top:-.125rem;overflow:hidden;text-overflow:ellipsis}.blui-user-menu-header-content .blui-user-menu-header-title-wrapper .blui-user-menu-header-subtitle.mat-subheading-2{margin-bottom:0}@media (max-width: 599px){.blui-user-menu-header-content{height:3.5rem}}\n"]
                },] }
    ];
    UserMenuHeaderComponent.propDecorators = {
        color: [{ type: i0.Input }],
        divider: [{ type: i0.Input }],
        subtitle: [{ type: i0.Input }],
        title: [{ type: i0.Input }],
        iconEl: [{ type: i0.ViewChild, args: ['icon', { static: true },] }]
    };

    var UserMenuModule = /** @class */ (function () {
        function UserMenuModule() {
        }
        return UserMenuModule;
    }());
    UserMenuModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [UserMenuComponent, UserMenuAvatarComponent, UserMenuHeaderComponent],
                    imports: [
                        common.CommonModule,
                        DrawerHeaderModule,
                        InfoListItemModule,
                        overlay.OverlayModule,
                        bottomSheet.MatBottomSheetModule,
                        card.MatCardModule,
                        toolbar.MatToolbarModule,
                    ],
                    exports: [UserMenuComponent, UserMenuAvatarComponent, UserMenuHeaderComponent],
                },] }
    ];

    /**
     * [MobileStepper Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-mobile-stepper--readme)
     *
     * The <MobileStepper> is used to minimally display progress when completing a workflow that requires multiple steps.
     *  There are three types of progress indicators supported, dots (default), text, and progress.
     */
    var MobileStepperComponent = /** @class */ (function () {
        function MobileStepperComponent() {
            /** Which type of indicator to use. Can be 'dots' | 'text' | 'progress'.
             *
             * `dots` - Each step appears as a dot. Visited steps will appear as a different color.
             *
             * `text` -  Text indicator which shows current step and total steps.  Example: "Step 1/5"
             *
             * `progress` - Appears as a progress bar that fills the further along as user is in the workflow.
             *
             * @default dots
             * */
            this.variant = 'dots';
            this.stepsArray = [];
        }
        MobileStepperComponent.prototype.ngOnChanges = function () {
            requireInput(['steps', 'activeStep'], this);
            this.stepsArray = Array(this.steps)
                .fill(0)
                .map(function (i) { return i; });
        };
        /** This is only used for progress variant. */
        MobileStepperComponent.prototype.getProgressFill = function () {
            return this.activeStep === 0 ? 0 : (this.activeStep / (this.stepsArray.length - 1)) * 100;
        };
        return MobileStepperComponent;
    }());
    MobileStepperComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'blui-mobile-stepper',
                    template: "<div class=\"blui-mobile-stepper-content\">\n    <div class=\"blui-mobile-stepper-back-button-wrapper\">\n        <ng-content select=\"[blui-back-button]\"></ng-content>\n    </div>\n    <div *ngIf=\"variant === 'dots'\" class=\"blui-mobile-stepper-dots\">\n        <div\n            *ngFor=\"let step of stepsArray; let index = index\"\n            class=\"blui-mobile-stepper-dot\"\n            [class.blui-mobile-stepper-dot-visited]=\"index < activeStep\"\n            [class.blui-mobile-stepper-dot-active]=\"index === activeStep\"\n            [class.blui-mobile-stepper-dot-unvisited]=\"index > activeStep\"\n        ></div>\n    </div>\n    <div *ngIf=\"variant === 'text'\" class=\"mat-subheading-2\">{{ activeStep + 1 }} / {{ stepsArray.length }}</div>\n    <mat-progress-bar *ngIf=\"variant === 'progress'\" mode=\"determinate\" [value]=\"getProgressFill()\"></mat-progress-bar>\n\n    <div class=\"blui-mobile-stepper-next-button-wrapper\">\n        <ng-content select=\"[blui-next-button]\"></ng-content>\n    </div>\n</div>\n",
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None,
                    host: {
                        class: 'blui-mobile-stepper',
                    },
                    styles: [".blui-mobile-stepper{display:flex;width:100%}.blui-mobile-stepper-content{display:flex;justify-content:space-between;align-items:center;flex-grow:1}.blui-mobile-stepper-content button{margin:1rem 16px}.blui-mobile-stepper-dots{display:flex;flex-direction:row}.blui-mobile-stepper-dot{height:.5rem;width:.5rem;background-color:gray;border-radius:100%;margin:0 .25rem}.blui-mobile-stepper-dot-active{background-color:#00f}.blui-mobile-stepper-display-none{display:none}.blui-mobile-stepper-next-button-wrapper,.blui-mobile-stepper-back-button-wrapper{display:flex;flex:1}.blui-mobile-stepper-next-button-wrapper{justify-content:end}.blui-mobile-stepper-back-button-wrapper{justify-content:start}\n"]
                },] }
    ];
    MobileStepperComponent.propDecorators = {
        activeStep: [{ type: i0.Input }],
        steps: [{ type: i0.Input }],
        variant: [{ type: i0.Input }]
    };

    var MobileStepperModule = /** @class */ (function () {
        function MobileStepperModule() {
        }
        return MobileStepperModule;
    }());
    MobileStepperModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [MobileStepperComponent],
                    imports: [common.CommonModule, button.MatButtonModule, progressBar.MatProgressBarModule],
                    exports: [MobileStepperComponent],
                },] }
    ];

    /*
     * Public API Surface of dot stepper
     */

    /**
     Copyright (c) 2021-present, Eaton

     All rights reserved.

     This code is licensed under the BSD-3 license found in the LICENSE file in the root directory of this source tree and at https://opensource.org/licenses/BSD-3-Clause.
     **/

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AppBarComponent = AppBarComponent;
    exports.AppBarModule = AppBarModule;
    exports.ChannelValueComponent = ChannelValueComponent;
    exports.ChannelValueModule = ChannelValueModule;
    exports.DrawerBodyComponent = DrawerBodyComponent;
    exports.DrawerBodyModule = DrawerBodyModule;
    exports.DrawerComponent = DrawerComponent;
    exports.DrawerFooterComponent = DrawerFooterComponent;
    exports.DrawerFooterModule = DrawerFooterModule;
    exports.DrawerHeaderComponent = DrawerHeaderComponent;
    exports.DrawerHeaderModule = DrawerHeaderModule;
    exports.DrawerLayoutComponent = DrawerLayoutComponent;
    exports.DrawerLayoutModule = DrawerLayoutModule;
    exports.DrawerModule = DrawerModule;
    exports.DrawerNavGroupComponent = DrawerNavGroupComponent;
    exports.DrawerNavGroupModule = DrawerNavGroupModule;
    exports.DrawerNavItemComponent = DrawerNavItemComponent;
    exports.DrawerNavItemModule = DrawerNavItemModule;
    exports.DrawerSubheaderComponent = DrawerSubheaderComponent;
    exports.DrawerSubheaderModule = DrawerSubheaderModule;
    exports.DropdownToolbarComponent = DropdownToolbarComponent;
    exports.DropdownToolbarModule = DropdownToolbarModule;
    exports.EmptyStateComponent = EmptyStateComponent;
    exports.EmptyStateModule = EmptyStateModule;
    exports.HeroBannerComponent = HeroBannerComponent;
    exports.HeroComponent = HeroComponent;
    exports.HeroModule = HeroModule;
    exports.InfoListItemComponent = InfoListItemComponent;
    exports.InfoListItemModule = InfoListItemModule;
    exports.ListItemTagComponent = ListItemTagComponent;
    exports.ListItemTagModule = ListItemTagModule;
    exports.MobileStepperComponent = MobileStepperComponent;
    exports.MobileStepperModule = MobileStepperModule;
    exports.ScoreCardComponent = ScoreCardComponent;
    exports.ScoreCardModule = ScoreCardModule;
    exports.SpacerComponent = SpacerComponent;
    exports.SpacerModule = SpacerModule;
    exports.ThreeLinerComponent = ThreeLinerComponent;
    exports.ThreeLinerModule = ThreeLinerModule;
    exports.UserMenuAvatarComponent = UserMenuAvatarComponent;
    exports.UserMenuComponent = UserMenuComponent;
    exports.UserMenuHeaderComponent = UserMenuHeaderComponent;
    exports.UserMenuModule = UserMenuModule;
    exports.ɵa = StateListener;
    exports.ɵb = DrawerService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=brightlayer-ui-angular-components.umd.js.map
