import { OnChanges, OnInit } from '@angular/core';
/**
 * [Spacer Component](https://brightlayer-ui-components.github.io/angular/?path=/info/components-spacer--readme)
 *
 * An invisible utility component that acts as a spacer element in various layouts.
 * It works with flexbox sizing or fixed sizing.
 */
export declare class SpacerComponent implements OnChanges, OnInit {
    /** Flex grow/shrink value for use in flex layouts
     *
     * @default 1
     * */
    flex: number;
    /** Height (in px) for static layouts */
    height: number;
    /** Width (in px) for static layouts */
    width: number;
    grow: string;
    display: string;
    ngOnInit(): void;
    ngOnChanges(): void;
    calcGrow(): void;
}
export declare class SpacerModule {
}
